#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "near.h"
#include "Memory.h"
#include "Time.h"
#define MIN(a,b) (a)<(b)? (a): (b);
#define MAX(a,b) (a)>(b)? (a): (b);
particle *p;
float x,y,z;
float epsilon2=0.04;
double f(double);
float mindist;

#define OFFSET 0.001
Box findbox(TPtlStruct *ptl, int nend){
	float xmin,ymin,zmin,xmax,ymax,zmax;
	float width;
	Box box;
	int i;
	box.x = box.y = box.z = 0.;
	xmax=ymax=zmax = -1.E25;
	xmin=ymin=zmin = 1.E25;
	for(i=0;i<nend;i++){
		xmin = MIN(xmin,ptl[i].r[0]);
		ymin = MIN(ymin,ptl[i].r[1]);
		zmin = MIN(zmin,ptl[i].r[2]);
		xmax = MAX(xmax,ptl[i].r[0]);
		ymax = MAX(ymax,ptl[i].r[1]);
		zmax = MAX(zmax,ptl[i].r[2]);
	}
	width = MAX(width,xmax-xmin);
	width = MAX(width,ymax-ymin);
	width = MAX(width,zmax-zmin);
	box.x = xmin;
	box.y = ymin;
	box.z = zmin;
	box.width = width;
	box.x = box.x -box.width*OFFSET;
	box.y = box.y -box.width*OFFSET;
	box.z = box.z -box.width*OFFSET;
	box.width = box.width + box.width*OFFSET*2.;
	return box;
}
#undef OFFSET
/* inverse of pi */
#define AMPW41 (-0.2387324)
#define AMPW42 (0.07957747)
inline float W4(dist,h){
	float twomr,r;
	r = dist/h;
	if(r<1.){
		/*
		return 1/PI*(1.-1.5*dist*dist+0.75*dist*dist*dist);
		*/
		return AMP41*((2.-r)*r*r-1.333333);
	}
	else if(r < 2.){
		twomr = (2.-r);
		/*
		return 1/PI*0.25*twomr*twomr*twomr;
		*/
		return AMP42*twomr*twomr*twomr;
	}
	else {
		return 0.;
	}
}
#undef AMPW41
#undef AMPW42
void findsphdensity(basicparticletype *bp,int np,int *nearindex, int Numnear, 
		float *densph){
	float *h;
	double std,mean;
	int ntmp;
	float tmpx,tmpy,tmpz;
	float *dist2;
	float fplmf,ptlmass;
	int i,j,k;
	int N,M;
	TPtlStruct *ptl;
	BeginEndTree beginend;
	Box box;
	TStruct *TREE;
	float theta = 1.;
	float wtime;
	long iseed=-9;
	float x0,y0,z0,pscale;
	float Rmin,Rmax,size;
	int index, *tmpindx;

	tmpindx = (int *)Malloc(sizeof(int)*Numnear,PPTR(tmpindx));

	p = (particle *) Malloc(sizeof(particle)*np,PPTR(p));
	for(i=0;i<np;i++){
		p[i].x = bp[i].x;
		p[i].y = bp[i].y;
		p[i].z = bp[i].z;
	}
	ptl = (TPtlStruct *)Malloc(sizeof(TPtlStruct)*np,PPTR(ptl));
	for(i=0;i<np;i++){
		ptl[i].type = TYPE_PTL;
		ptl[i].r[0] = bp[i].x;
		ptl[i].r[1] = bp[i].y;
		ptl[i].r[2] = bp[i].z;
		ptl[i].sibling = ptl+(i+1);
		ptl[i].mass = 1;
	}
	ptl[np-1].sibling = NULL;
	TREE = (TStruct *) Malloc(sizeof(TStruct)*np,PPTR(TREE));
	h = (float*) Malloc(sizeof(float)*np,PPTR(h));
	dist2 = (float*) Malloc(sizeof(float)*np*Numnear,PPTR(h));

	/*
	(void) WALLCLOCK();
	*/
	box = findbox(ptl,np);
	/*
	printf("rmin =%g %g %g with width=%g\n",box.x,box.y,box.z,box.width);
	*/
	Make_Tree(TREE,ptl,np,box);
	/*
	printf("CPU(Make_Tree_test)=%g\n",WALLCLOCK());
	*/
	mindist = 2.e25;
	for(i=0;i<np;i++){
		int res;
		float neardist;
		res = Find_Near(p+i,Numnear,TREE,ptl,&neardist,tmpindx,dist2);
		h[i] = neardist;
		for(j=0;j<Numnear;j++){
			nearindex[i*Numnear+j] = tmpindx[j];
		}
	}
	for(i=0;i<np*Numnear;i++) dist2[i] = sqrt(dist2[i]);

	k = 0;
	for(i=0;i<np;i++){
		densph[i] = 0.;
		for(j=0;j<Numnear;j++){
			densph[i] += W4(dist2[k],h[i]);
			k++;
		}
	}
	Free(dist2); Free(h);
	Free(TREE);Free(ptl);Free(p);Free(tmpindx);
	/*
	printf("ins=", tmpindx);
	fprintf(stdout,"Terminated with success\n");fflush(stdout);
	*/
	return;
}
