#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "tree.h"
#include "mathsub.h"
#include "force_spline.h"
typedef enum { FALSE=0, TRUE} inside;
inside open(particle *p,TStruct *tree, float theta){
	return (sqr(p->x-tree->mono[0]) 
		 + sqr(p->y-tree->mono[1]) 
		 + sqr(p->z-tree->mono[2] 
		 <(tree->dist2)/theta)? TRUE : FALSE);
	
}
/*
void CELLFORCE(p,ptr,force,ran2nran) 
particle *p;
pforce *force;
void *ptr;
float ran2nran;
*/
#define CELLFORCE(p,ptr,force,ran2nran) \
{\
	int ntmp;  \
	float tmpx,tmpy,tmpz,dist2;  \
	float xx,yy,zz,xy,xz,yz,tmpxx; \
	float qxx1,qxx2,qxx3,qxy,tmpdist;  \
	float fplmf1,fplmf2,fplmf3,fplmf4,tmptmp;  \
	TStruct *pointer;  \
	pointer = (TStruct *) ptr;  \
	tmpx = p->x-pointer->mono[0];  \
	tmpy = p->y-pointer->mono[1];  \
	tmpz = p->z-pointer->mono[2];  \
	dist2 = tmpx*tmpx + tmpy*tmpz + tmpz*tmpz;  \
	xx = pointer->quad[0];  \
	yy = pointer->quad[1];  \
	zz = pointer->quad[2];  \
	xy = pointer->quad[3];  \
	xz = pointer->quad[4];  \
	yz = pointer->quad[5];  \
	tmpxx = xx + yy + zz;  \
	qxx1 = xx*tmpx+xy*tmpy+xz*tmpz;  \
	qxx2 = xy*tmpx+yy*tmpy+yz*tmpz;  \
	qxx3 = xz*tmpx+yz*tmpy+zz*tmpz;  \
	qxy = xx*tmpx*tmpx+yy*tmpy*tmpy+zz*tmpz*tmpz+  \
		2.*(xy*tmpx*tmpy+xz*tmpx*tmpz+yz*tmpy*tmpz); \
	ntmp = dist2/ran2nran;  \
	tmpdist = (dist2-ntmp*ran2nran);  \
	fplmf1 = diff[ntmp*4] + slope[ntmp*4]*tmpdist;  \
	fplmf2 = diff[ntmp*4+1] + slope[ntmp*4+1]*tmpdist;  \
	fplmf3 = diff[ntmp*4+2] + slope[ntmp*4+2]*tmpdist;  \
	fplmf4 = diff[ntmp*4+3] + slope[ntmp*4+3]*tmpdist;  \
	tmptmp = pointer->mass * fplmf1 + tmpxx*fplmf2 +  \
		qxy*fplmf4;  \
	force->x += tmpx*tmptmp+qxx1*fplmf3;  \
	force->y += tmpy*tmptmp+qxx2*fplmf3;  \
	force->z += tmpz*tmptmp+qxx3*fplmf3;  \
}

/*
void PARTICLEFORCE(p,ptr,force,ran2nran) 
particle *p;
pforce *force;
void *ptr;
float ran2nran;
*/
#define PARTICLEFORCE(p,ptr,force,ran2nran) \
{ \
	int ntmp;  \
	float tmpx,tmpy,tmpz,dist2;  \
	float fplmf;  \
	tmpx = p->x-((TPtlStruct*)ptr)->r[0];  \
	tmpy = p->y-((TPtlStruct*)ptr)->r[1];  \
	tmpz = p->z-((TPtlStruct*)ptr)->r[2];  \
	dist2 = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;  \
	ntmp = dist2/ran2nran;  \
	fplmf = diff[ntmp*4] + slope[ntmp*4] * (dist2-ntmp*ran2nran);  \
	force->x = tmpx * fplmf;  \
	force->y = tmpy * fplmf;  \
	force->z = tmpz * fplmf;  \
}

/* 
 * *p is the position at which you want to calculate force using tree
 * theta is the opening angle for tree walk
 * *tree is the tree structure.
 */

void treeforce(particle *p,float theta,TStruct *tree, TPtlStruct *ptl,
		pforce *force){
	void *ptr;
	void *Start_Tree;
	int sign;
	Start_Tree = (void *)tree;
	ptr = (void *)tree;
	force->x = force->y = force->z = 0.;
	while(ptr != NULL){
		switch(((TYPE*)ptr)->type ) {
			case TYPE_TREE:
				switch(open(p,ptr,theta)){
					case TRUE: 
						ptr = (void *)(((TStruct*)ptr)->daughter);
						break;
					case FALSE: 
						CELLFORCE(p,ptr,force,ran2nran);
						ptr = (void *)(((TStruct*)ptr)->sibling);
				}
				break;
			default: 
				PARTICLEFORCE(p,ptr,force,ran2nran);
				ptr = (void*)(((TPtlStruct*)ptr)->sibling);
		}
	}
	return;
}
void Make_Tree(TStruct *TREE_START,TPtlStruct *ptl,Box box){
	BeginEndTree beginend;
	TStruct *TREE;
	TPtlStruct *ptr;
	TREE=TREE_START;
	TREE->daughter = &ptl[0];
	TREE->sibling = NULL;
	TREE->type = TYPE_TREE;
	TREE->r0[0] = box.x;
	TREE->r0[1] = box.y;
	TREE->r0[2] = box.z;
	TREE->mono[0] = TREE->mono[1] = TREE->mono[2] = 0.;
	TREE->quad[0] = TREE->quad[1] = TREE->quad[2] = 0.;
	TREE->quad[3] = TREE->quad[4] = TREE->quad[5] = 0.;
	beginend = divide_node(TREE,TREE+1,ptl,box,TREE);
}
BeginEndTree divide_node(TStruct *TREE_START,TStruct *NewTree, 
		TPtlStruct *ptl, Box box,TStruct *Mother_Node){ 
	BeginEndTree beginend;
	TStruct *p2tree,tmpnode[8];
	void *from_sibling,*from_below_rank;
	TPtlStruct *p2ptl,*tmpptr,*tmpptr2;
	Box tmpbox[8];
	int i,j,k,mnode,mx,my,mz;
	float x0,y0,z0,inv_halfw,halfw;
	float tmpx,tmpy,tmpz,tmpdist2,distmax;
	float ptlmass;

	p2ptl = ptl;
	x0 = box.x;
	y0 = box.y;
	z0 = box.z;
	halfw = box.width*0.5;
	inv_halfw = 1./halfw;
	/* initialize temporary tree array */
	for(i=0;i<8;i++) {
		tmpnode[i].type = TYPE_TREE;
		tmpnode[i].sibling = tmpnode[i].daughter = NULL;
		tmpnode[i].mass = 0;
		tmpnode[i].Nparticle = 0;
		tmpnode[i].L = halfw;
		mx = IMOD(i,2);
		my = IMOD(i,4)/2;
		mz = i/4;
		tmpnode[i].r0[0] = x0 + mx*halfw;
		tmpnode[i].r0[1] = y0 + my*halfw;
		tmpnode[i].r0[2] = z0 + mz*halfw;
		tmpbox[i].width = halfw;
		tmpbox[i].x = x0+IMOD(i,2)*halfw;
		tmpbox[i].y = y0+(IMOD(i,4)/2)*halfw;
		tmpbox[i].z = z0+(i/4)*halfw;
		tmpnode[i].mono[0] = tmpnode[i].mono[1] = tmpnode[i].mono[2] = 0.;
		tmpnode[i].mrr = 0.;
		tmpnode[i].quad[0] = tmpnode[i].quad[1] = tmpnode[i].quad[2] = 
		tmpnode[i].quad[3] = tmpnode[i].quad[4] = tmpnode[i].quad[5] = 0.;
	}
	while(p2ptl != NULL){
		mx = (int)((p2ptl->r[0] - x0)*inv_halfw);
		my = (int)((p2ptl->r[1] - y0)*inv_halfw);
		mz = (int)((p2ptl->r[2] - z0)*inv_halfw);
		mnode = mx + 2*my + 4*mz;
		ptlmass = p2ptl->mass;
		tmpnode[mnode].mass += ptlmass;
		tmpnode[mnode].Nparticle ++; 
		/* dipole expansion */
		tmpnode[mnode].mono[0] += ptlmass * p2ptl->r[0];
		tmpnode[mnode].mono[1] += ptlmass * p2ptl->r[1];
		tmpnode[mnode].mono[2] += ptlmass * p2ptl->r[2];
		tmpptr = tmpnode[mnode].daughter;
		tmpptr2 = p2ptl->sibling;
		tmpnode[mnode].daughter = p2ptl;
		p2ptl->sibling = tmpptr;
		p2ptl = tmpptr2;
	}
	for(i=0;i<8;i++){
		tmpnode[i].mono[0] /= tmpnode[i].mass;
		tmpnode[i].mono[1] /= tmpnode[i].mass;
		tmpnode[i].mono[2] /= tmpnode[i].mass;
	}
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE){
			p2ptl = tmpnode[i].daughter;
			distmax = -1.E20;
			while(p2ptl != NULL){
				tmpx = p2ptl->r[0] - tmpnode[i].mono[0];
				tmpy = p2ptl->r[1] - tmpnode[i].mono[1];
				tmpz = p2ptl->r[2] - tmpnode[i].mono[2];
				tmpnode[i].mrr += tmpdist2 = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;
				distmax = MAX(distmax,tmpdist2);
				tmpnode[i].quad[0] += tmpx*tmpx;
				tmpnode[i].quad[1] += tmpy*tmpy;
				tmpnode[i].quad[2] += tmpz*tmpz;
				tmpnode[i].quad[3] += tmpx*tmpy;
				tmpnode[i].quad[4] += tmpx*tmpz;
				tmpnode[i].quad[5] += tmpy*tmpz;
				p2ptl = p2ptl->sibling;
			}
			tmpnode[i].dist2 = distmax;
		}
	}
	/* Making link from Mother Node */
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle > 0) break;
	}
	if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE){
		Mother_Node->daughter = (void *)NewTree;
	}
	else {
		Mother_Node->daughter = (void *) tmpnode[i].daughter ;
	}
	from_sibling = NULL;
	from_below_rank = NULL;
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE){
			*NewTree = tmpnode[i];
			/*  sibling 忡  带 Ų. */
			if(from_sibling != NULL){ /* if first sibling */
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = NewTree;
			}
			if(from_below_rank != NULL) {
				((GENERAL_TPtl_POINTER*)from_below_rank)->sibling = NewTree;
				from_below_rank = NULL;
			}
			from_sibling = NewTree;
			NewTree ++;
			beginend = divide_node(TREE_START,NewTree,
					(TPtlStruct *)(NewTree-1)->daughter, tmpbox[i],NewTree-1);
			NewTree = beginend.start;
			from_below_rank = beginend.End;
		}
		else if(tmpnode[i].Nparticle > 0) {
			if(from_sibling != NULL){
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = 
					tmpnode[i].daughter;
			}
			if(from_below_rank != NULL) {
				((GENERAL_TPtl_POINTER*)from_below_rank)->sibling = 
					tmpnode[i].daughter;
				from_below_rank = NULL;
			}
			tmpptr = tmpnode[i].daughter;
			while(tmpptr != NULL){
				from_sibling = tmpptr;
				tmpptr = tmpptr->sibling;
			}
		}
	}
	/* if there is a pointer from below rank, then it should be
	 * a pointer of from_sibling 
	 */
	if(from_below_rank != NULL) beginend.End = from_below_rank;
	else beginend.End = from_sibling;
	/* This is the new memory for Tree structure */
	beginend.start = NewTree;
	return beginend;
}
