#include<stdio.h>
#include<math.h>
#include "tree.h"
#define NSPLINE 100000
/*
#define RANGE2 16
*/
#define RANGE2 64
float diff[(NSPLINE+1)][4],slope[(NSPLINE+1)][4];
float ran2nran;
double a[8] = {
	1./256./256.,
	0.78224E+00L,
	0.37971E-06L,
	-0.60338E+00L,
	-0.34419E-07L,
	-0.39741E+01L,
	-0.10607E+01L,
	-0.38145E+00L
};
double f_a(double x){
	return 0.5L*( a[1]*x/sinh(a[1]*x)/cosh(a[1]*x) - 1.L );
}
double fp_a(double x){
	return a[1]*0.5L/sinh(a[1]*x)/cosh(a[1]*x)*
		( 1.L-a[1]*x*(tanh(a[1]*x)+1.L/tanh(a[1]*x)) );
}
double f_b(double x){
	return 0.125L*( 3.L-a[1]*x*(2.L*a[1]*x*tanh(a[1]*x)+3.L)/
			sinh(a[1]*x)/cosh(a[1]*x) );
}
double fp_b(double x){
	return -a[1]*0.125L/sinh(a[1]*x)/cosh(a[1]*x)*
		( a[1]*x*tanh(a[1]*x)-pow(2.L*a[1]*x*tanh(a[1]*x),2)+
		  3.L-3.L*a[1]*x/tanh(a[1]*x) );
}

/*
void i_force_spline(float *diff,float *slope,float epsilon){
*/
void i_force_spline(){
	double a2x,tanha2x,expdxx,f_a,f_b,fp_a,fp_b,x;
	double ar,br,arprime,brprime;
	double plmf_1,plmf_2,plmf_3,plmf_4;
	double pmf1_1,pmf1_2,pmf1_3,pmf1_4;
	double pmf2_1,pmf2_2,pmf2_3,pmf2_4;
	double pmf3_1,pmf3_2,pmf3_3,pmf3_4;
	double xstep;
	int i,j,k;
	double e;
	e = epsilon;
	ran2nran=(float)RANGE2/(float)NSPLINE;

	for(i=0;i<NSPLINE+1;i++){
		x = (double)i * (double)RANGE2 / (double)NSPLINE;
		if(i == 0) x = (1.e-6L) * (1.e-6L);
		x = sqrt(x);
		/* plmf --> multipole expansion of Plummer force
		 */
		plmf_1 = -a[0] / pow(x*x+e*e,1.5);
		plmf_2 =  a[0]*1.5L/pow(x*x+e*e,2.5);
		plmf_3 =  a[0]*3.0L/pow(x*x+e*e,2.5);
		plmf_4 = -a[0]*7.5L/pow(x*x+e*e,3.5);
		/* pmf1_1 --> multipole expansion of the force of tanh(x)/x potential
		 */
		a2x = a[1]*x;
		/*
		ar = f_a(x);
		br = f_b(x);
		arprime = fp_a(x);
		brprime = fp_b(x);
		*/
		ar = 0.5L*( a[1]*x/sinh(a[1]*x)/cosh(a[1]*x) - 1.L );
		br = 0.125L*( 3.L-a[1]*x*(2.*a[1]*x*tanh(a[1]*x)+3.L)/
				sinh(a[1]*x)/cosh(a[1]*x) );
		arprime = a[1]/2.L/sinh(a[1]*x)/cosh(a[1]*x)*
			( 1.L-a[1]*x*(tanh(a[1]*x)+1.L/tanh(a[1]*x)) );
		brprime = -a[1]*0.125L/sinh(a[1]*x)/cosh(a[1]*x)* 
			( a[1]*x*tanh(a[1]*x)-pow(2.L*a[1]*x*tanh(a[1]*x),2)+ 
			  3.L-3.L*a[1]*x/tanh(a[1]*x) );
		tanha2x = tanh(a2x);
		pmf1_1 = a[0]/x/x*(a2x*(1.L-tanha2x*tanha2x)-tanha2x)/x;
		pmf1_2 = a[0]/x/x*( ar*(a2x*(1.L-tanha2x*tanha2x)-tanha2x)/x/x +
				tanha2x*(x*arprime-2.L*ar)/x/x )/x;
		pmf1_3 = a[0]*8.L*tanha2x*br/x/x/x/x/x;
		pmf1_4 = a[0]/x*( 4.L*br/x/x
				*(a2x*(1.-tanha2x*tanha2x)-tanha2x)/x/x
				+4.L*tanha2x/x/x*(x*brprime-4.L*br)/x/x )/x/x;
		/* pmf2_1 --> multipole expansion of the force of (x+x^3)*exp(x^2)
		 * potential */
		expdxx = exp(a[3]*x*x);
		pmf2_1 = 2.L*a[2]*expdxx*(1.L+a[3]*x*x); 
		pmf2_2 = 2.L*a[2]*a[3]*expdxx*(2.L+a[3]*x*x);
		pmf2_3 = 4.L*a[2]*a[3]*expdxx*(2.L+a[3]*x*x);
		pmf2_4 = 4.L*a[2]*a[3]*a[3]*expdxx*(3.L+a[3]*x*x);
		/* pmf3_1 --> multipole expansion of the force of (1+x^2+x^4)*exp(x^2)
		 * potential */
		pmf3_1 = 1.L/x*(a[4]+a[5]*x*x+a[6]*x*x*x*x)*exp(a[7]*x*x);
		pmf3_2 = 1.L/x*exp(a[7]*x*x)*(-0.5L*a[4]/x/x+(0.5L*a[5]+a[4]*a[7])
				+(1.5L*a[6]+a[5]*a[7])*x*x+a[6]*a[7]*x*x*x*x);
		pmf3_3 = exp(a[7]*x*x)*(-a[4]/x/x/x+(a[5]+2.*a[4]*a[7])/x
				+(3.L*a[6]+2.L*a[5]*a[7])*x +2.L*a[6]*a[7]*x*x*x);
		pmf3_4 = 1.L*exp(a[7]*x*x)/x
		    	*( 1.5L*a[4]/x/x/x/x -(0.5L*a[5]+2.*a[4]*a[7])/(x*x)
				+(1.5L*a[6]+2.L*a[5]*a[7]+2.L*a[4]*a[7]*a[7])
				+(6.L*a[6]*a[7]+2.L*a[5]*a[7]*a[7])*x*x
				+2.L*a[6]*a[7]*a[7]*x*x*x*x );
		diff[i][0] = plmf_1-pmf1_1-pmf2_1-pmf3_1;
		diff[i][1] = plmf_2-pmf1_2-pmf2_2-pmf3_2;
		diff[i][2] = plmf_3-pmf1_3-pmf2_3-pmf3_3;
		diff[i][3] = plmf_4-pmf1_4-pmf2_4-pmf3_4;
	}
	for(i=0;i<NSPLINE;i++){
		x = (double)i * (double)RANGE2 / (double)NSPLINE;
		if(i == 0) x = (1.e-6L) * (1.e-6L);
		xstep = (double)(i+1)*(double)RANGE2/(double)NSPLINE - x;
		slope[i][0] = (diff[i+1][0]-diff[i][0])/xstep;
		slope[i][1] = (diff[i+1][1]-diff[i][1])/xstep;
		slope[i][2] = (diff[i+1][2]-diff[i][2])/xstep;
		slope[i][3] = (diff[i+1][3]-diff[i][3])/xstep;
	}
	/* warning 
	*f(r+r') = f(r) + r'^2/r * f'(r) + 0.5/r/r *(f''(r) - f'(r)/r) Q_ab r^a r^b
	 */
	for(i=0;i<50;i++){
		for(j=0;j<3;j++){
			slope[i][j] = slope[50][j];
			diff[i][j] = diff[50][j];
		}
	}
	return;
}
