#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "tree.h"
#include "Memory.h"
#include "Time.h"
/*
#define N 116
*/
float ran2(long *);
void check_tree();
particle *p;
pforce *force;
void force_spline();
int main(int argc,char *argv[]){
	int i,j,k;
	int N,M;
	TPtlStruct *ptl;
	BeginEndTree beginend;
	Box box;
	TStruct *TREE;
	float theta = 0.3*0.3;
	float wtime;
	long iseed=-6;
	Make_Total_Memory();
	i_force_spline(0.02);
	for(k=100;k<100000;k+=100){
		N = k;
		M = N;
		ptl = (TPtlStruct *) Malloc(sizeof(TPtlStruct)*N,&ptl);
		p = (particle *) Malloc(sizeof(particle)*M,&p);
		force = (pforce *) Malloc(sizeof(pforce)*M,&force);
		TREE = (TStruct *) Malloc(sizeof(TStruct)*N,&TREE);
		wtime = WALLCLOCK();
		box.x = box.y = box.z = 0.;
		box.width = 1.;
		for(i=0;i<N;i++){
			ptl[i].type = TYPE_PTL;
			p[i].x = ptl[i].r[0] = ran2(&iseed);
			p[i].y = ptl[i].r[1] = ran2(&iseed);
			p[i].z = ptl[i].r[2] = ran2(&iseed);
			ptl[i].sibling = &ptl[i+1];
			ptl[i].mass = 1;
		}
		for(i=N;i<M;i++){
			p[i].x = ran2(&iseed)*7;
			p[i].y = ran2(&iseed)*7;
			p[i].z = ran2(&iseed)*7;
		}
		ptl[N-1].sibling = NULL;
		(void)WALLCLOCK();
		/*
		TREE->daughter = &ptl[0];
		TREE->sibling = NULL;
		TREE->type = TYPE_TREE;
		beginend = divide_node(TREE,TREE+1,ptl,box,TREE);
		*/
		Make_Tree(TREE,ptl,N,box);
		printf("%g  ellapsed ..",WALLCLOCK());
		printf("%d :",N);
		/*
		check_tree(TREE,ptl);
		*/
		for(i=0;i<M;i++){
			treeforce(p+i,theta,TREE,ptl,force+i);
		}
		printf("%g  ellapsed \n",WALLCLOCK());
		Free(TREE);Free(ptl);Free(p);Free(force);
	}
	fprintf(stdout,"Terminated with success\n");fflush(stdout);
	return 1;
}
#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0/IM1)
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)

float ran2(long *idum)
{
	int j;
	long k;
	static long idum2=123456789;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if (*idum <= 0) {
		if (-(*idum) < 1) *idum=1;
		else *idum = -(*idum);
		idum2=(*idum);
		for (j=NTAB+7;j>=0;j--) {
			k=(*idum)/IQ1;
			*idum=IA1*(*idum-k*IQ1)-k*IR1;
			if (*idum < 0) *idum += IM1;
			if (j < NTAB) iv[j] = *idum;
		}
		iy=iv[0];
	}
	k=(*idum)/IQ1;
	*idum=IA1*(*idum-k*IQ1)-k*IR1;
	if (*idum < 0) *idum += IM1;
	k=idum2/IQ2;
	idum2=IA2*(idum2-k*IQ2)-k*IR2;
	if (idum2 < 0) idum2 += IM2;
	j=iy/NDIV;
	iy=iv[j]-idum2;
	iv[j] = *idum;
	if (iy < 1) iy += IMM1;
	if ((temp=AM*iy) > RNMX) return RNMX;
	else return temp;
}
#undef IM1
#undef IM2
#undef AM
#undef IMM1
#undef IA1
#undef IA2
#undef IQ1
#undef IQ2
#undef IR1
#undef IR2
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
