/* It adopts the tidal radius of the elliptical orbits. May 2008 */
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include <mpi.h>
#include "Memory.h"
#include "defs.h"
#include "tree.h"
#define free(a) Free(a)
#define PEAKTHRESHOLD 30.
/*
#define BOUNDITER 8
*/
#define BOUNDITER 4
#define BOUND 1
#define UNBOUND 0 
#define COREDENRESOLUTION 1.e-4
#define MINCORENMEM 15
#define NSHELLDIVIDE 10
#define MAX_TIDAL_R 2.e10
extern int myid,nid;
/*    Ѵ. */
extern double onesolarmass;
extern double com2real,real2com,potentfact;
extern double pntmass;
extern double r1kineticfact,r2kineticfact;
extern float amax,a,rng,size,hubble;
extern int ng,nspace;
extern int nx,ny,nz;
extern float omep,omeplam,acoeff[8];
extern float epsilon;

/*
#define COREIDFROMESCORE(i) ((int)(score[i].core-core))
*/
#define KP2BPID(kp,i) ((int)(kp[i].bp-bp))
#define SCOREID2COREID(i) ((int)(score[i].core-core))


int sorttype(const void *a,const void *b){
	float *aa,*bb;
	aa = (float*)a;
	bb = (float*)b;
	if(aa<bb) return -1;
	else if(aa>bb) return 1;
	else return 0;
}

int numstack;
Box findbox(TPtlStruct *, int);
Box foffindbox(FoFTPtlStruct *, int);
#include "header.h"
int Motherrank = motherrank;
extern float m_tidal[NUM_MASS],r_tidal[NUM_MASS];
typedef struct Vector3d{
	float x,y,z;
} Vector3d;
typedef struct Kptype{
	float x,y,z;
	float vx,vy,vz;
	basicparticletype *bp;
}Kptype;

void mklocalize(basicparticletype *bp,lint np,float *xinit,float *yinit,
		float *zinit,float *xmax,float *ymax,float *zmax){
	float min,max;
	basicparticletype *tmpr;
	float *tmp,*tmparr;
	lint i,j;
	int *idx;
	float maxdist,tmpdist;
	int upbound;
	*xinit = nx; *xmax = -nx;
	*yinit = ny; *ymax = -ny;
	*zinit = nz; *zmax = -nz;
	for(i=0;i<np;i++){
		tmpr = bp+i;
		*xinit = MIN(*xinit,tmpr->x);
		*xmax  = MAX(*xmax ,tmpr->x);
		*yinit = MIN(*yinit,tmpr->y);
		*ymax  = MAX(*ymax ,tmpr->y);
		*zinit = MIN(*zinit,tmpr->z);
		*zmax  = MAX(*zmax ,tmpr->z);
	}
	if(floor(*xinit) <= 0+nblur && ceil(*xmax) >= nx-nblur){
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;tmpr = bp;
		for(i=0;i<np;i++) *(tmp++) = (tmpr++)->x;
		qsort(tmparr,np,sizeof(float),sorttype);
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[i+1] - tmparr[i];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			bp[i].x += nx;
		}
		*xinit = bp[upbound+1].x;
		*xmax = bp[upbound].x;
		Free(tmparr);
	}
	if(floor(*yinit) <= 0+nblur && ceil(*ymax) >= ny-nblur){
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;
		tmpr = bp;
		for(i=0;i<np;i++) *(tmp++) = tmpr++->y;
		qsort(tmparr,np,sizeof(float),sorttype);
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[i+1] - tmparr[i];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			bp[i].y += ny;
		}
		*yinit = bp[upbound+1].y;
		*ymax = bp[upbound].y;
		Free(tmparr);
	}
	if(floor(*zinit) <= 0+nblur && ceil(*zmax) >= nz-nblur){
		tmparr = (float *) Malloc(sizeof(float)*np,PPTR(tmparr));
		tmp = tmparr;
		tmpr = bp;
		for(i=0;i<np;i++) *(tmp++) = tmpr++->z;
		qsort(tmparr,np,sizeof(float),sorttype);
		maxdist = -10.;
		for(i=0;i<np-1;i++){
			tmpdist = tmparr[i+1] - tmparr[i];
			if(tmpdist > maxdist) {
				upbound = i;
				maxdist = tmpdist;
			}
		}
		for(i=0;i<=upbound;i++){
			bp[i].z += nz;
		}
		*zinit = bp[upbound+1].z;
		*zmax = bp[upbound].z;
		Free(tmparr);
	}
}

#define NOT 0 /* This is used for the flag of WorkingParticle */

#define WP_RESET 0x00
#define WP_PEAK  0x01
#define WP_VISITED 0x02
#define WP_CORE  0x04
#define WP_SHELL 0x08
#define WP_BOUND 0x10
#define WP_REMAINING 0x20
/*
#define WP_BOUND 0x40
#define WP_REST  0x80
*/

#define RESET_WHOLE_FLAGS_WP(x) (wp[x].flag  = WP_RESET)

#define SET_VISITED(x) (wp[x].flag |= WP_VISITED)
#define SET_PEAK(x) (wp[x].flag |= WP_PEAK)
#define SET_CORE(x) (wp[x].flag |= WP_CORE)
#define SET_SHELL(x) (wp[x].flag |= WP_SHELL)
#define SET_BOUND(x) (wp[x].flag |= WP_BOUND)
#define SET_REMAINING(x) (wp[x].flag |= WP_REMAINING)

#define UNSET_VISITED(x) (wp[x].flag &= (~WP_VISITED))
#define UNSET_PEAK(x) (wp[x].flag &= (~WP_PEAK))
#define UNSET_CORE(x) (wp[x].flag &= (~WP_CORE))
#define UNSET_SHELL(x) (wp[x].flag &= (~WP_SHELL))
#define UNSET_BOUND(x) (wp[x].flag &= (~WP_BOUND))
#define UNSET_REMAINING(x) (wp[x].flag &= (~WP_REMAINING))

#define IS_PEAK(x) (wp[x].flag & WP_PEAK)
#define IS_VISITED(x) (wp[x].flag & WP_VISITED)
#define IS_CORE(x) (wp[x].flag & WP_CORE)
#define IS_SHELL(x) (wp[x].flag & WP_SHELL)
#define IS_BOUND(x) (wp[x].flag & WP_BOUND)
#define IS_REMAINING(x) (wp[x].flag & WP_REMAINING)

#define TOGGLE_PEAK(x) (wp[x].flag ^= WP_PEAK)
#define TOGGLE_VISITED(x) (wp[x].flag ^= WP_VISITED)
#define TOGGLE_CORE(x) (wp[x].flag ^= WP_CORE)
#define TOGGLE_SHELL(x) (wp[x].flag ^= WP_SHELL)
#define TOGGLE_BOUND(x) (wp[x].flag ^= WP_BOUND)
#define TOGGLE_REMAINING(x) (wp[x].flag ^= WP_REMAINING)

#define SET_MEMBER_ID(a,b) (wp[a].haloid=b)

unsigned char setbits(unsigned char x,int p) {
    unsigned char b;
	b = x|(~((~0)<<1) << (p-1));
	return b;
}

typedef struct WorkingParticle{
	float den;
	unsigned char flag;
	int haloid;
} WorkingParticle;
WorkingParticle *wp;


#define CORE_RESET 0x00
#define CORE_ENCLOSED 0x01
#define CORE_CONFIRMED 0x02
#define REAL_CORE 0x04

#define RESET_CORE_ENCLOSED(x) ( core[x].flag = CORE_RESET)
#define SET_CORE_ENCLOSED(x) ( core[x].flag |= CORE_ENCLOSED)
#define UNSET_CORE_ENCLOSED(x) ( core[x].flag &= (~CORE_ENCLOSED))
#define IS_CORE_ENCLOSED(x) ( core[x].flag & CORE_ENCLOSED)
#define TOGGLE_CORE_ENCLOSED(x) ( core[x].flag ^= CORE_ENCLOSED)

#define RESET_REAL_CORE(x) ( core[x].flag = CORE_RESET)
#define SET_REAL_CORE(x) ( core[x].flag |= REAL_CORE)
#define UNSET_REAL_CORE(x) ( core[x].flag &= (~REAL_CORE))
#define IS_REAL_CORE(x) ( core[x].flag & REAL_CORE)
#define TOGGLE_REAL_CORE(x) ( core[x].flag ^= REAL_CORE)
/* SCORE means the shell cores */
#define RESET_SCORE_ENCLOSED(x) ( score[x].flag = CORE_RESET)
#define SET_SCORE_ENCLOSED(x) ( score[x].flag |= CORE_ENCLOSED)
#define UNSET_SCORE_ENCLOSED(x) ( score[x].flag &= (~CORE_ENCLOSED))
#define IS_SCORE_ENCLOSED(x) ( score[x].flag & CORE_ENCLOSED)
#define TOGGLE_SCORE_ENCLOSED(x) ( score[x].flag ^= CORE_ENCLOSED)

#define RESET_SCORE_CONFIRMED(x) ( score[x].flag = CORE_RESET)
#define SET_SCORE_CONFIRMED(x) ( score[x].flag |= CORE_CONFIRMED)
#define UNSET_SCORE_CONFIRMED(x) ( score[x].flag &= (~CORE_CONFIRMED))
#define IS_SCORE_CONFIRMED(x) ( score[x].flag & CORE_CONFIRMED)
#define TOGGLE_SCORE_CONFIRMED(x) ( score[x].flag ^= CORE_CONFIRMED)


typedef struct Coretype{
	int peak;
	int nummem;
	float coredensity;
	float cx,cy,cz;
	float cvx,cvy,cvz;
	float Rtidal;
	unsigned char flag;
}Coretype;

typedef struct Coresorttype{
	int nmem;
	Coretype *core;
}Coresorttype;
typedef struct Coresortdentype{
	int nmem;
	float density;
	Coretype *core;
	unsigned char flag;
}Coresortdentype;


#define NSHELL2P(x) (shell[x].nlinkedparticle)
#define SHELL2P(x) (shell[x].linkedparticle)
#define NSHELL2C(x) (shell[x].nlinkedcore)
#define SHELL2C(x) (shell[x].linkedcore)
typedef struct Shelltype{
	int nlinkedcore;
	int *linkedcore;
	int nlinkedparticle;
	int *linkedparticle;
}Shelltype;
Shelltype shell[10000];
int nshell,numcore;

int finddenpeak(float *den,int numneigh,int *neighbor,int np,
		Coretype *core){
	int i,j,k;
	float *me,*you;
	int iflag;
	numcore = 0;
	for(i=0;i<np;i++){
		if(den[i] > PEAKTHRESHOLD){
			iflag = 1;
			k = i*numneigh;
			for(j=0;j<numneigh;j++){
				if(den[neighbor[k+j]] > den[i]) {
					iflag = 0;
					break;
				}
			}
			if(iflag == 1){
				core[numcore].peak = i;
				numcore ++;
			}
		}
	}
	return numcore;
}
void Dump2WorkingParticle(float *density,int np,Coretype *core,int numcore){
	int i,now;
	for(i=0;i<np;i++) {
		wp[i].den = density[i];
		RESET_WHOLE_FLAGS_WP(i);
	}
	for(i=0;i<numcore;i++) SET_PEAK(core[i].peak);
}
int CountMemInRadius2(basicparticletype *bp,int np,int *plist,
		float cx,float cy,float cz,float radius2){
	int i,j,k;
	int ncount;
	float tmpx,tmpy,tmpz,dist2;
	ncount = 0;
	for(i=0;i<np;i++){
		tmpx = bp[plist[i]].x-cx; 
		tmpy = bp[plist[i]].y-cy; 
		tmpz = bp[plist[i]].z-cz;
		dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
		if(dist2 < radius2) ncount ++;
	}
	return ncount;
}
int GetShellParticleFromRestParticleLIST(basicparticletype  *bp,int np,int ishell, int *plist,
		Coretype *icore){
	int i,j,k,bid;
	int nmem,omem;
	float cx,cy,cz,tmpx,tmpy,tmpz,tidalr2,dist2;

	nmem = 0;
	/* Include shell particles that are not bound to any halos. */
	for(i=0;i<NSHELL2P(ishell);i++)
		if(IS_BOUND((bid=SHELL2P(ishell)[i]))==NOT) plist[nmem++] = bid;
	for(i=0;i<np;i++) if(IS_REMAINING(i) != NOT) plist[nmem++] = i;

	cx = icore->cx; cy = icore->cy; cz = icore->cz;
	tidalr2 = icore->Rtidal;
	tidalr2 = tidalr2*tidalr2;
	omem = nmem;
	nmem = 0;
	for(i=0;i<omem;i++){
		tmpx = bp[plist[i]].x -cx;
		tmpy = bp[plist[i]].y -cy;
		tmpz = bp[plist[i]].z -cz;
		dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
		if(dist2 <= tidalr2) {
			plist[nmem++] = plist[i];
		}
	}
	return nmem;
}
int GetMemCandidateList(int np,int haloid, int *plist,int ishell){
	int i,j,k;
	int nmem,nlcore;

	nmem  = 0;
	for(i=0;i<np;i++) if(wp[i].haloid == haloid) plist[nmem++] = i;
	for(i=ishell+1;i<nshell;i++){
		nlcore = NSHELL2C(i);
		for(j = 0;j<nlcore;j++)
			if(SHELL2C(i)[j] == haloid)
				for(k=0;k<NSHELL2P(i);k++)
					plist[nmem++] = SHELL2P(i)[k];

	}
	return nmem;
}
inline int GET_NONENCLOSED_ID(Coretype  *core, int numcore,float threshold){
	int i;
	for(i=0;i<numcore;i++) {
		if(IS_CORE_ENCLOSED(i) == NOT && core[i].coredensity > threshold) {
			return i;
		}
	}
	return -1;
}
void SaveRemainingParticles2LastShell(int np,Coretype  *core,int numcore){
	int i,j,k;
	int nrest,ishell;

	nrest = 0;
	for(i=0;i<np;i++) if(IS_CORE(i) == NOT && IS_SHELL(i) ==NOT) nrest++;
	if(nrest ==0) return;

	if(nshell >0) {
		ishell = nshell -1;
		if(SHELL2P(ishell)) 
			SHELL2P(ishell) = Realloc(SHELL2P(ishell),sizeof(int)*(NSHELL2P(ishell)+nrest));
		else SHELL2P(ishell) = Malloc(sizeof(int)*nrest,PPTR(SHELL2P(ishell)));

		for(i=0;i<np;i++)
			if(IS_CORE(i) == NOT && IS_SHELL(i) ==NOT) {
				SET_SHELL(i);
				UNSET_REMAINING(i);
				SHELL2P(ishell)[(NSHELL2P(ishell)++)] = i;
				SET_MEMBER_ID(i,NOT_HALO_MEMBER);
			}
	}
	else if(nshell ==0){
		SHELL2P(nshell) = Malloc(sizeof(int)*nrest,PPTR(SHELL2P(nshell)));
		for(i=0;i<np;i++)
			if(IS_CORE(i) == NOT && IS_SHELL(i) ==NOT) {
				SET_SHELL(i);
				UNSET_REMAINING(i);
				SET_MEMBER_ID(i,NOT_HALO_MEMBER);
				SHELL2P(nshell)[(NSHELL2P(nshell)++)] = i;
			}
		NSHELL2C(nshell) = numcore;
		SHELL2C(nshell) = Malloc(sizeof(int)*numcore,PPTR(SHELL2C(nshell)));
		for(i=0;i<numcore;i++) SHELL2C(nshell)[i] = i;
		nshell++;
	}
	else {
		fprintf(stderr,"Strange value of nshell in SaveRemainingParticles2LastShell\n");
		fprintf(stderr,"Ok.. Now exiting with nshell =%d\n",nshell);
		exit(999);
	}
}
void GetShellParticlesPeaks(int np,int *neighbor,int NumNeighbor,
		Coretype *core,int numcore, float dthreshold){
	int i,j,k,jj,kk;
	int icore,*contactlist,nlist;
	int numenclosedpeaks;
	int now,new;
	int nowcore;

	contactlist = (int *)Malloc(sizeof(int)*np,PPTR(contactlist));
	for(i=0;i<numcore;i++) RESET_CORE_ENCLOSED(i);

	while((nowcore = GET_NONENCLOSED_ID(core,numcore,dthreshold))>=0){
		for(j=0;j<np;j++) UNSET_VISITED(j);
		now = nlist = 0;
		SET_VISITED((contactlist[nlist++]= core[nowcore].peak));
		while(now<nlist){
			kk = contactlist[now]*NumNeighbor;
			for(k=0;k<NumNeighbor;k++){
				new = neighbor[kk];
				if(wp[new].den > dthreshold && IS_VISITED(new) == NOT){
					SET_VISITED(new);
					contactlist[nlist++] = new;
				}
				kk++;
			}
			now++;
		}
		if(nlist==0) continue;
		/* erase shell or core particles from this shell-particle list
		 * and turn on the shell flag */
		SHELL2P(nshell) = Malloc(sizeof(int)*nlist,PPTR(SHELL2P(nshell)));
		now = 0;
		for(j=0;j<nlist;j++){
			if(IS_SHELL(contactlist[j])==NOT && IS_CORE(contactlist[j])==NOT){
				SHELL2P(nshell)[now++] = contactlist[j];
				SET_SHELL(contactlist[j]);
				UNSET_REMAINING(contactlist[j]);
				SET_MEMBER_ID(contactlist[j],NOT_HALO_MEMBER);
			}
		}
		NSHELL2P(nshell) = now;
		SHELL2P(nshell) = Realloc(SHELL2P(nshell),sizeof(int)*NSHELL2P(nshell));

		NSHELL2C(nshell) = 0;
		SHELL2C(nshell) = (int *)Malloc(sizeof(int)*numcore,PPTR(SHELL2C(nshell)));
		for(j=0;j<nlist;j++){
			now = contactlist[j];
			if(IS_PEAK(now)!=NOT){
				for(icore=0;icore<numcore;icore++){
					if(core[icore].peak == now){
						SET_CORE_ENCLOSED(icore);
						SHELL2C(nshell)[NSHELL2C(nshell)++] = icore;
						break;
					}
				}
			}
		}
		SHELL2C(nshell) = Realloc(SHELL2C(nshell),sizeof(int)*NSHELL2C(nshell));
		nshell ++;
	}
	Free(contactlist);
}
int coresortden(const void *a,const void *b){
	Coresortdentype *aa,*bb;
	aa = (Coresortdentype *)a;
	bb = (Coresortdentype *)b;
	if(aa->density < bb->density) return 1;
	else if(aa->density > bb->density) return -1;
	else return 0;
}
int SmartFinding(basicparticletype *bp,int np,Coretype *core,int numcore,
		int *neighbor,int NumNeighbor){
	int i,j,k,breakflag;
	int num;
	int ncontact,now,new,kk,*contactlist;
	Coresortdentype *score;
	float upden,downden,minden,denthr;
	num = 0;
	for(i=0;i<numcore;i++) if(core[i].nummem < MINCORENMEM) num++;
#ifdef DEBUG
	printf("The number of erased core is %d from %d\n",num,numcore);
#endif
	if(num <2) {
		num = 0;
		for(i=0;i<numcore;i++) 
			if(core[i].nummem >= MINCORENMEM) core[num++]=core[i];
		return num;
	}
	score = (Coresortdentype *)Malloc(sizeof(Coresortdentype)*num,PPTR(score));
	num = 0;
	for(i=0;i<numcore;i++) if(core[i].nummem < MINCORENMEM){
		score[num].nmem = core[i].nummem;
		score[num].core = core + i;
		score[num].density = wp[core[i].peak].den; /* peak density */
		num++;
	}

	minden = 2.e23;
	for(i=0;i<np;i++) minden = MIN(minden,wp[i].den);
	/* Sort score in reverse order of peak density */
	qsort(score,num,sizeof(Coresortdentype),coresortden);
	/* Unset the peak flag with less-member cores */
	for(i=0;i<numcore;i++) 
		if(core[i].nummem < MINCORENMEM) UNSET_PEAK(core[i].peak);
	for(i=0;i<num;i++) {
		RESET_SCORE_ENCLOSED(i);
		RESET_SCORE_CONFIRMED(i);
	}
	contactlist = (int *)Malloc(sizeof(int)*np,PPTR(contactlist));
	for(i=0;i<num;i++){
		if(IS_SCORE_ENCLOSED(i) == NOT){
			upden = (score[i].core)->coredensity;
			downden = minden;
			while(fabs(upden-downden)/downden>COREDENRESOLUTION){
				for(j=0;j<np;j++) UNSET_VISITED(j);
				breakflag = ncontact = now = 0;
				denthr = 0.5*(upden+downden);
				SET_VISITED((contactlist[ncontact++] = (score[i].core)->peak));
				while(now<ncontact && breakflag ==0){
					kk = contactlist[now]*NumNeighbor;
					for(k=0;k<NumNeighbor;k++){
						new = neighbor[kk];
						if(wp[new].den>denthr){
							if(IS_VISITED(new) ==NOT && IS_PEAK(new) == NOT){
								SET_VISITED(new);
								contactlist[ncontact++] = new;
							}
							else if(IS_VISITED(new) == NOT && IS_PEAK(new) !=NOT){
								downden = denthr;
								breakflag = 1;
								break;
							}

						}
						kk++;
					}
					now++;
				}
				if(breakflag==0) upden = denthr;
			}
			(score[i].core)->coredensity = (denthr = upden);

			/* Now scoop up core particles */
			for(j=0;j<np;j++) UNSET_VISITED(j);
			ncontact = now = 0;
			SET_VISITED((contactlist[ncontact++] = (score[i].core)->peak));
			while(now<ncontact){
				kk = contactlist[now]*NumNeighbor;
				for(k=0;k<NumNeighbor;k++){
					new = neighbor[kk];
					if(wp[new].den > denthr && IS_VISITED(new) == NOT){
						SET_VISITED(new);
						contactlist[ncontact++] = new;
					}
					kk++;
				}
				now++;
			}

			if(ncontact >= MINCORENMEM) {/* restore this as a meaningful peak */
				SET_PEAK((score[i].core)->peak);
				SET_SCORE_CONFIRMED(i);
			}
			else {
				UNSET_PEAK((score[i].core)->peak);
				UNSET_SCORE_CONFIRMED(i);
			}
			for(j=i+1;j<num;j++){
				k = (score[j].core)->peak;
				if(IS_VISITED(k) != NOT ) {
					/* delete this peak forever since there is no possibility 
					 * for this peak to get a meaningful peak */
					SET_SCORE_ENCLOSED(j);
					UNSET_SCORE_CONFIRMED(j);
				}
			}
		}
	}
	Free(contactlist);

	for(i=0;i<numcore;i++) SET_REAL_CORE(i);
	for(i=0;i<num;i++) 
		if(IS_SCORE_CONFIRMED(i) == NOT) UNSET_REAL_CORE(SCOREID2COREID(i));
	num = 0;
	for(i=0;i<numcore;i++){
		if(IS_REAL_CORE(i) != NOT){/* If this is real core */
			core[num++] = core[i];
		}
	}
#ifdef DEBUG
	printf("Total number of survived cores is %d from %d\n",num,numcore);
#endif
	numcore = num;
	return numcore;
}
/* Comerford MNRAS 379 190 */
double get_concentration(int mp){
	double mass = mp*pntmass*hubble/onesolarmass;
	double mstar= 1.3E13L;
	double redshift;
	double res;
	redshift = amax/a - 1.L;
	res = 14.5 *pow(mass/mstar,-0.13)/(1.L+redshift);
	return res;
}
double get_alpha(double c,double s){
	double res;
	{
		res = 2.L-(c*s/(1.L+c*s))*(c*s/(1.L+c*s));
		res = res/(log(1.L+c*s)-c*s/(1.L+c*s));
		return res;
	}
}
/* Definition of v for flat cosmologies */
#define RHOC 2.7755E11L
#define vv (18.L*M_PI*M_PI+82.L*(omep-1.L)-39.L*pow(omep-1.L,2.L))
double gnfw(double c){
	double res;
	res =  1./(log(1.L+c)-c/(1.L+c));
	return res;
}
double get_tidal_ellipse(int np, int myid, int mp, int uid, int mpall, Coretype *core){
	double mratio,alpha,ellipse_contribution;
	double w2,wx,wy,wz,dx,dy,dz,dist2,dvx,dvy,dvz;
	double dist,pot,res,s,Rvir,Mvir,v2,nfwc;
	double kpdratio;
	mratio = (double)np/(double)mp;
	dx = core[myid].cx - core[uid].cx;
	dy = core[myid].cy - core[uid].cy;
	dz = core[myid].cz - core[uid].cz;
	dist = sqrt(dx*dx+dy*dy+dz*dz);
	dvx = core[myid].cvx - core[uid].cvx;
	dvy = core[myid].cvy - core[uid].cvy;
	dvz = core[myid].cvz - core[uid].cvz;
	v2 = dvx*dvx+dvy*dvy+dvz*dvz;
	wx = dy*dvz-dz*dvy;
	wy = dz*dvx-dx*dvz;
	wz = dx*dvy-dy*dvx;
	w2 = (wx*wx+wy*wy+wz*wz)/(dist*dist);
	pot = mp/dist;
	kpdratio = r2kineticfact*r2kineticfact/potentfact;
	ellipse_contribution = w2/pot * kpdratio;
	/* This is for the case when the minor body is not bound to the major body. */
	/* This is the case when the pair do not bound to each other. 
	 * In this case the contribution of the orbital motion to the
	 * tidal radius is assumed to be negligible. */
	Mvir = mpall * pntmass*hubble/onesolarmass;
/*
#error This should be modified further.
*/
	Rvir = pow(3.*Mvir/(4.L*M_PI*vv*RHOC),0.3333333333333L);
	Rvir = Rvir/size*rng;/* Change to the simulation length scale */
	s = dist/Rvir;
	nfwc = get_concentration(mpall);
#ifdef OLD_BETA
	if(ellipse_contribution > 2.L){
		ellipse_contribution = 0.L;
	}
#else
	if(s>1) {
		double fact;
		fact = v2/(mpall/Rvir)*kpdratio;
		if(fact > 2.L) ellipse_contribution = 0.L;
	}
	else {
		double fact;
		fact = v2*s/(gnfw(nfwc)*log(1.L+nfwc*s)*mpall/Rvir )*kpdratio;
		if(fact > 2.L) ellipse_contribution = 0.L;
	}
#endif
	alpha = get_alpha(get_concentration(mpall),s);
	res = pow(mratio/(ellipse_contribution+alpha),0.33333333333333L);
#ifdef DEBUG
	/*
	printf(" ellipse_c= %g alpha= %g c= %g s= %g\n",ellipse_contribution,alpha,get_concentration(mpall),s);
	*/
#endif
	return res;
}
#undef vv
#undef RHOC

int  FindCoreDensity(basicparticletype *bp,int np,int *neighbor,
		int NumNeighbor,Coretype *core,int numcore){
	int i,j,k,jj,kk,breakflag;
	float denthr,upden,downden;
	int *contactlist,ncontact,now,new;
	int newnmem,iflag;
	float minden;
	double cx,cy,cz;
	double cvx,cvy,cvz;

	iflag = 0;
recycling:
	contactlist = (int *)Malloc(sizeof(int)*np,PPTR(contactlist));
	for(i=0;i<np;i++) SET_MEMBER_ID(i,NOT_HALO_MEMBER);
	minden = 1.e23;
	for(i=0;i<np;i++) minden = MIN(minden,wp[i].den);
	for(i=0;i<numcore;i++){
		/* Now find core density threshold */
		upden = wp[core[i].peak].den;
		downden = minden;
		while(fabs(upden-downden)/downden > COREDENRESOLUTION){
			/* initialization before a search for the core density */
			for(j=0;j<np;j++) UNSET_VISITED(j);
			breakflag = 0; ncontact = now = 0;
			denthr = 0.5*(upden+downden);
			SET_VISITED((contactlist[ncontact++] = core[i].peak));
			while(now < ncontact && breakflag ==0){
				kk = contactlist[now]*NumNeighbor;
				for(k=0;k<NumNeighbor;k++){
					new = neighbor[kk];
					if(wp[new].den>denthr) {
						if(IS_VISITED(new) == NOT && IS_PEAK(new) == NOT){
							SET_VISITED(new);
							contactlist[ncontact++] = new;
						}
						else if(IS_VISITED(new) == NOT && IS_PEAK(new) != NOT){
							downden = denthr;
							breakflag = 1;
							break;
						}
					}
					kk ++;
				}
				now++;
			}
			if(breakflag==0) upden = denthr;
		}
		core[i].coredensity = (denthr = upden);
		/* Now scoop up core particles */
		for(j=0;j<np;j++) UNSET_VISITED(j);
		ncontact = now = 0;
		SET_VISITED((contactlist[ncontact++] = core[i].peak));
		while(now<ncontact){
			kk = contactlist[now]*NumNeighbor;
			for(k=0;k<NumNeighbor;k++){
				new = neighbor[kk];
				if(wp[new].den > denthr && IS_VISITED(new) == NOT){
					SET_VISITED(new);
					contactlist[ncontact++] = new;
				}
				kk++;
			}
			now++;
		}
		for(j=0;j<ncontact;j++) {
			SET_CORE(contactlist[j]);
			SET_BOUND(contactlist[j]);
			UNSET_REMAINING(contactlist[j]);
			SET_MEMBER_ID(contactlist[j],i);
		}
		/* Now core[i].center is temporarily considered to be center for tidal radius calculation.*/
		/* But in the case of kinetic energy measurement the center of mass is the center of the body. */
		if(iflag != 0){
			cx = cy = cz = cvx = cvy = cvz = 0;
			for(j=0;j<ncontact;j++){
				cx += bp[contactlist[j]].x;
				cy += bp[contactlist[j]].y;
				cz += bp[contactlist[j]].z;
				cvx += bp[contactlist[j]].vx;
				cvy += bp[contactlist[j]].vy;
				cvz += bp[contactlist[j]].vz;
			}
			cx = cx/(double) ncontact;
			cy = cy/(double) ncontact;
			cz = cz/(double) ncontact;
			cvx = cvx/(double) ncontact;
			cvy = cvy/(double) ncontact;
			cvz = cvz/(double) ncontact;
			core[i].cx = cx; core[i].cy = cy; core[i].cz = cz;
			core[i].cvx = cvx; core[i].cvy = cvy; core[i].cvz = cvz;
		}
		core[i].nummem = ncontact;
#ifdef DEBUG
		printf("C%d has number %d\n",i,core[i].nummem);
#endif
	}
	Free(contactlist);
#ifdef DEBUG
	printf("Now Found the core densities for %d cores\n",numcore);
#endif
	if(iflag ==0){
		/* Deleting peaks of core particles less than minimum number */
		iflag = 1;
#ifdef OLD
		newnmem  =0;
		for(i=0;i<numcore;i++){
			if(core[i].nummem >= MINCORENMEM) core[newnmem++] = core[i];
		}
		numcore = newnmem;
		for(i=0;i<np;i++) RESET_WHOLE_FLAGS_WP(i);
		for(i=0;i<numcore;i++) SET_PEAK(core[i].peak);
#else
		numcore = SmartFinding(bp,np,core,numcore,neighbor,NumNeighbor);
#endif
		goto recycling; /* go and start again */
	}
	return numcore;
}

void Self_Halo_Potent(int np,Vector3d *r,float *penergy){
    TStruct *TREE;
    TPtlStruct *ptl;
    particle p;
    Box box;
    float theta2=0.5;
    int i,j,k;
    TREE = (TStruct *) Malloc(sizeof(TStruct)*np,PPTR(TREE));
    ptl = (TPtlStruct *) Malloc(sizeof(TPtlStruct)*np,PPTR(ptl));
    for(i=0;i<np;i++){
        ptl[i].type = TYPE_PTL;
        ptl[i].r[0] = r[i].x; ptl[i].r[1] = r[i].y; ptl[i].r[2] = r[i].z;
        ptl[i].mass = 1;
		ptl[i].sibling = &ptl[i+1];
    }
	ptl[np-1].sibling = NULL;

    box = findbox(ptl,np);
    Make_Tree(TREE,ptl,np,box);
    for(i=0;i<np;i++){
        p.x = ptl[i].r[0]; p.y = ptl[i].r[1]; p.z = ptl[i].r[2];
        penergy[i] = treeplumpotential(&p,theta2,TREE,ptl)*potentfact;
        
    }
    Free(ptl);
    Free(TREE);
}
void External_Halo_Potent(int nend,Vector3d *r,float *penergy, int snp,
		Vector3d *sr){
    TStruct *TREE;
    TPtlStruct *ptl;
    particle p;
    Box box;
    float theta2=0.5;
    int i,j,k;
    static int np;
    TREE = (TStruct *) Malloc(sizeof(TStruct)*snp,PPTR(TREE));
    ptl = (TPtlStruct *) Malloc(sizeof(TPtlStruct)*snp,PPTR(ptl));
    for(i=0;i<snp;i++){
        ptl[i].type = TYPE_PTL;
        ptl[i].r[0] = sr[i].x; ptl[i].r[1] = sr[i].y; ptl[i].r[2] = sr[i].z;
        ptl[i].mass = 1;
		ptl[i].sibling = &ptl[i+1];
    }
	ptl[snp-1].sibling = NULL;

    box = findbox(ptl,snp);
    Make_Tree(TREE,ptl,snp,box);
    for(i=0;i<nend;i++){
        p.x = r[i].x; p.y = r[i].y; p.z = r[i].z;
        penergy[i] = treeplumpotential(&p,theta2,TREE,ptl)*potentfact;
        
    }
    Free(ptl);
    Free(TREE);
}
int CheckExternalTE(Kptype *tkp,int tnp,unsigned char *bndflag,
		Kptype *skp,int snp, Coretype *icore){
	int i,j,k,nbound;
	float *kenergy,*penergy;
	double cx,cy,cz,cvx,cvy,cvz;
	float distx,disty,distz;
	float tmpvx,tmpvy,tmpvz;
	Vector3d *tr,*tvr;
	Vector3d *sr;

	tr = (Vector3d*)Malloc(sizeof(Vector3d)*tnp,PPTR(tr));
	tvr = (Vector3d*)Malloc(sizeof(Vector3d)*tnp,PPTR(tvr));
	kenergy = (float*)Malloc(sizeof(float)*tnp,PPTR(kenergy));
	penergy = (float*)Malloc(sizeof(float)*tnp,PPTR(penergy));

	/*
	cx = cy = cz = cvx = cvy = cvz = 0.L;
	for(i=0;i<tnp;i++){
		cx += (tr[i].x = tkp[i].x);
		cy += (tr[i].y = tkp[i].y);
		cz += (tr[i].z = tkp[i].z);
		cvx += (tvr[i].x = tkp[i].vx);
		cvy += (tvr[i].y = tkp[i].vy);
		cvz += (tvr[i].z = tkp[i].vz);
	}
	cx = cx/(double)tnp; cy = cy/(double)tnp; cz = cz/(double)tnp;
	cvx = cvx/(double)tnp; cvy = cvy/(double)tnp; cvz = cvz/(double)tnp;
	*/
	for(i=0;i<tnp;i++){
		tr[i].x = tkp[i].x;
		tr[i].y = tkp[i].y;
		tr[i].z = tkp[i].z;
		tvr[i].x = tkp[i].vx;
		tvr[i].y = tkp[i].vy;
		tvr[i].z = tkp[i].vz;
	}
	cx = icore->cx; cy = icore->cy; cz = icore->cz;
	cvx = icore->cvx; cvy = icore->cvy; cvz = icore->cvz;

	for(i=0;i<tnp;i++){
		distx = (tr[i].x-cx)*r1kineticfact;
		disty = (tr[i].y-cy)*r1kineticfact;
		distz = (tr[i].z-cz)*r1kineticfact;
		tmpvx = distx + (tvr[i].x-cvx)*r2kineticfact;
		tmpvy = disty + (tvr[i].y-cvy)*r2kineticfact;
		tmpvz = distz + (tvr[i].z-cvz)*r2kineticfact;
		kenergy[i] = 0.5*(tmpvx*tmpvx+tmpvy*tmpvy+tmpvz*tmpvz);
	}

	sr = (Vector3d*)Malloc(sizeof(Vector3d)*snp,PPTR(sr));
	for(i=0;i<snp;i++){
		sr[i].x = skp[i].x; sr[i].y = skp[i].y; sr[i].z = skp[i].z;
	}
	External_Halo_Potent(tnp,tr,penergy,snp,sr);
	Free(sr);

	nbound = 0;
	for(i=0;i<tnp;i++){
		if(kenergy[i] > -penergy[i]) {
			bndflag[i] = UNBOUND;
		}
		else {
			bndflag[i] = BOUND;
			nbound ++;
		}
	}
	Free(penergy); Free(kenergy);
	Free(tvr);Free(tr);
	return nbound;
}
int MULTIHALOSHELL(Kptype *tkp,int tnp, Kptype *skp, int snp,
		basicparticletype *bp,int np,Coretype *icore){
	int i,j,k;
	unsigned char *bndflag;
	int nmem,omem;
	bndflag = (unsigned char *)Malloc(sizeof(unsigned char)*tnp,PPTR(bndflag));
	for(i=0;i<tnp;i++) bndflag[i] = BOUND;
	omem = CheckExternalTE(tkp,tnp,bndflag,skp,snp,icore);
	nmem = 0;
	for(i=0;i<tnp;i++) {
		if(bndflag[i] == BOUND) {
			SET_BOUND(KP2BPID(tkp,i));
			tkp[nmem++] = tkp[i];
		}
		else {
			SET_REMAINING(KP2BPID(tkp,i));
			UNSET_BOUND(KP2BPID(tkp,i));
			/* */
			SET_MEMBER_ID(KP2BPID(tkp,i),NOT_HALO_MEMBER);
		}
	}
	Free(bndflag);
	return nmem;
}

int CheckSelfTE(Kptype *kp,int np,unsigned char *bndflag, Coretype *icore){
	int i,j,k,nbound;
	float *kenergy,*penergy;
	double cx,cy,cz,cvx,cvy,cvz;
	float distx,disty,distz;
	float tmpvx,tmpvy,tmpvz;
	Vector3d *r,*vr;

	r = (Vector3d*)Malloc(sizeof(Vector3d)*np,PPTR(r));
	vr = (Vector3d*)Malloc(sizeof(Vector3d)*np,PPTR(vr));
	kenergy = (float*)Malloc(sizeof(float)*np,PPTR(kenergy));
	penergy = (float*)Malloc(sizeof(float)*np,PPTR(penergy));
	/*
	*/
	if(icore !=NULL){
		for(i=0;i<np;i++){
			r[i].x = kp[i].x;
			r[i].y = kp[i].y;
			r[i].z = kp[i].z;
			vr[i].x = kp[i].vx;
			vr[i].y = kp[i].vy;
			vr[i].z = kp[i].vz;
		}
		cx = icore->cx; cy = icore->cy; cz = icore->cz;
		cvx = icore->cvx; cvy = icore->cvy; cvz = icore->cvz;
	}
	else {
		cx = cy = cz = cvx = cvy = cvz = 0.L;
		for(i=0;i<np;i++){
			cx += (r[i].x = kp[i].x);
			cy += (r[i].y = kp[i].y);
			cz += (r[i].z = kp[i].z);
			cvx += (vr[i].x = kp[i].vx);
			cvy += (vr[i].y = kp[i].vy);
			cvz += (vr[i].z = kp[i].vz);
		}
		cx = cx/(double)np; cy = cy/(double)np; cz = cz/(double)np;
		cvx = cvx/(double)np; cvy = cvy/(double)np; cvz = cvz/(double)np;
	}

	for(i=0;i<np;i++){
		distx = (r[i].x-cx)*r1kineticfact;
		disty = (r[i].y-cy)*r1kineticfact;
		distz = (r[i].z-cz)*r1kineticfact;
		tmpvx = distx + (vr[i].x-cvx)*r2kineticfact;
		tmpvy = disty + (vr[i].y-cvy)*r2kineticfact;
		tmpvz = distz + (vr[i].z-cvz)*r2kineticfact;
		kenergy[i] = 0.5*(tmpvx*tmpvx+tmpvy*tmpvy+tmpvz*tmpvz);
	}
#ifdef DEBUG
	printf("Just before Self_halo_Potent np=%d r=%g %g %g\n",np,r[0].x,r[0].y,r[0].z);
#endif
	Self_Halo_Potent(np,r,penergy);
	nbound = 0;
	for(i=0;i<np;i++){
		if(kenergy[i] > -penergy[i]) {
			bndflag[i] = UNBOUND;
		}
		else {
			bndflag[i] = BOUND;
			nbound ++;
		}
	}
	/*
#ifdef DEBUG
	for(j=0;j<np;j++){
		printf("P%d of np = %d is ke %g and pe %g bnd? = %d\n",j,np,
				kenergy[j],penergy[j],bndflag[j]);
	}
#endif
*/
	Free(penergy); Free(kenergy);
	Free(vr);Free(r);
	return nbound;
}
int ALONEHALO(Kptype *kp,int np,basicparticletype *bp,int haloid){
	int i,j,k;
	unsigned char *bndflag;
	int nmem,onmem;
	bndflag = (unsigned char *)Malloc(sizeof(unsigned char)*np,PPTR(bndflag));
	for(i=0;i<np;i++) bndflag[i] = BOUND;
	onmem = np;
	for(i=0;i<BOUNDITER;i++){
		nmem = 0;
		for(j=0;j<onmem;j++){
			if(bndflag[j] == BOUND){
				kp[nmem++] = kp[j];
			}
		}
		if(nmem==0) {
			Free(bndflag);
			return nmem;
		}
		nmem = CheckSelfTE(kp,(k=nmem),bndflag,NULL);
		/*
		nmem = CheckSelfTE(kp,(k=nmem),bndflag);
		*/
		if(nmem == onmem  || nmem ==0) {
			break;
		}
		onmem = nmem;
	}
	Free(bndflag);
	for(i=0;i<nmem;i++) SET_MEMBER_ID(KP2BPID(kp,i),haloid);
#ifdef DEBUG
	printf("alone halo loses member particles from %d to %d\n",np,nmem);
#endif
	return nmem;
}
int SINGLEHALO(int nkp,Kptype *kp,int np,basicparticletype *bp,int haloid, Coretype *core){
	int i,j,k;
	unsigned char *bndflag;
	int nmem;
	bndflag = (unsigned char*)Malloc(sizeof(unsigned char)*np,PPTR(bndflag));
	for(i=0;i<nkp;i++) bndflag[i] = BOUND;

	nmem = CheckSelfTE(kp,nkp,bndflag,core);

	for(i=0;i<nkp;i++) {
		if(bndflag[i]==BOUND) {
			SET_MEMBER_ID(KP2BPID(kp,i),haloid);
			UNSET_REMAINING(KP2BPID(kp,i));
		}
		else if(wp[KP2BPID(kp,i)].haloid == haloid){
			SET_MEMBER_ID(KP2BPID(kp,i),NOT_HALO_MEMBER);
			SET_REMAINING(KP2BPID(kp,i));
		}
	}
	Free(bndflag);
	return nmem;
}
int coresort(const void *a,const void *b){
	Coresorttype *aa,*bb;
	aa = (Coresorttype *)a;
	bb = (Coresorttype *)b;
	if(aa->nmem < bb->nmem) return -1;
	else if(aa->nmem > bb->nmem) return +1;
	else return 0;
}
typedef struct Memtype{
	int num;
	double cx,cy,cz;
	Vector3d *List;
} Memtype;
/*
Memtype member[40000];
*/
void AdGetTidalRCenterCore(Coretype *core,int numcore,
		Coresorttype *score,int ncore,basicparticletype *bp,int np){
	int i,j,k;
	int sid,bid,inum;
	int snp,bnp,mtmp;
	float dist,tmpx,tmpy,tmpz,dist2,r2,r1;
	double scx,scy,scz,bcx,bcy,bcz;
	Memtype *member;
	member = (Memtype *)Malloc(sizeof(Memtype)*numcore,PPTR(member));
	for(i=0;i<numcore;i++) member[i].num = 0;
	for(i=0;i<np;i++) if(wp[i].haloid>=0) (member[wp[i].haloid].num)++;
	for(i=0;i<numcore;i++){
		if(member[i].num ==0) {
			member[i].List = NULL;
		}
		else {
			member[i].List = (Vector3d*)
				Malloc(sizeof(Vector3d)*member[i].num,PPTR(member[i].List));
			member[i].num = 0;
		}
		/*
		member[i].cx = member[i].cy = member[i].cz = 0.L;
		*/
	}
	for(i=0;i<np;i++)
		if(wp[i].haloid>=0) {
			k = wp[i].haloid;
			((member[k].List)+member[k].num)->x = bp[i].x;
			((member[k].List)+member[k].num)->y = bp[i].y;
			((member[k].List)+member[k].num)->z = bp[i].z;
			/*
			member[k].cx += bp[i].x;
			member[k].cy += bp[i].y;
			member[k].cz += bp[i].z;
			*/
			(member[k].num)++;
		}
	/*
	for(i=0;i<numcore;i++){
		member[i].cx = member[i].cx/(double)(member[i].num);
		member[i].cy = member[i].cy/(double)(member[i].num);
		member[i].cz = member[i].cz/(double)(member[i].num);
	}
	*/
	for(i=0;i<ncore;i++){
		sid = SCOREID2COREID(i);
		snp = member[sid].num;
		core[sid].Rtidal = MAX_TIDAL_R;

		/*
		scx = member[sid].cx; scy = member[sid].cy; scz = member[sid].cz;
		core[sid].cx = scx; core[sid].cy = scy; core[sid].cz = scz;
		*/
		scx = core[sid].cx; scy = core[sid].cy; scz = core[sid].cz;
		core[sid].nummem = snp;
		if(snp>0){
			for(j=i+1;j<ncore;j++){
				bid = SCOREID2COREID(j);
				bnp = member[bid].num;
				/*
				bcx = member[bid].cx; bcy = member[bid].cy; bcz = member[bid].cz;
				*/
				bcx = core[bid].cx; bcy = core[bid].cy; bcz = core[bid].cz;
				r2 = (bcx-scx)*(bcx-scx)+(bcy-scy)*(bcy-scy)+(bcz-scz)*(bcz-scz);
				if(bnp>0){
					inum = 0;
					for(k=0;k<bnp;k++){
						tmpx = ((member[bid].List+k)->x) - bcx;
						tmpy = ((member[bid].List+k)->y) - bcy;
						tmpz = ((member[bid].List+k)->z) - bcz;
						dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
						if(dist2< r2) inum++;
					}
					if(inum >0){
						mtmp = (int)((float) snp / (float) inum * (float) NUM_MASS);
						if(mtmp >= NUM_MASS) {
							/*
							core[sid].Rtidal = MIN(core[sid].Rtidal,sqrt(r2));
							*/
						}
						else {
							double tidal_radius;
							tidal_radius  = get_tidal_ellipse(snp,sid,inum,bid,bnp,core);
							core[sid].Rtidal = MIN(core[sid].Rtidal, sqrt(r2)*tidal_radius);
							/*
							core[sid].Rtidal = MIN(core[sid].Rtidal, sqrt(r2)*r_tidal[mtmp]);
							core[sid].Rtidal = MIN(core[sid].Rtidal, 
							sqrt(r2)*pow((double)snp/(double)inum/1.5,0.3333L));
							*/
						}
					}
					else{
						core[sid].Rtidal = MIN(core[sid].Rtidal, MAX_TIDAL_R);
					}

				}
			}
		}
		else {
			core[sid].Rtidal = 0.;
		}
#ifdef DEBUG
		printf("C%d has tidal radius %g in r1=%g for nmem = %d\n",sid,core[sid].Rtidal,sqrt(r2),snp);
#endif
	}
	for(i=numcore-1;i>=0;i--) Free(member[i].List);
	Free(member);
}
int GetMemList(int np,int haloid, int *plist){
	int i,j,k;
	int nmem,nlcore;
	nmem  = 0;
	for(i=0;i<np;i++) if(wp[i].haloid == haloid) plist[nmem++] = i;
	return nmem;
}

#define getcenter(list,nlist,xx,yy,zz,c,id){\
	int kk;\
	xx=yy=zz=0.L;\
	for(kk=0;kk<nlist;kk++){\
		xx+=bp[list[kk]].x; yy+=bp[list[kk]].y; zz+=bp[list[kk]].z;\
	}\
	xx = xx/nlist;yy=yy/nlist;zz=zz/nlist;\
	c[id].cx = xx; c[id].cy = yy; c[id].cz = zz;\
}
void GetTidalRCenterCore(Coretype *core,int numcore,
		Coresorttype *score,int ncore,basicparticletype *bp,int np){
	int i,j,k;
	int sid,bid,inum;
	int *slist,*blist,snp,bnp,mtmp;
	float dist,tmpx,tmpy,tmpz,dist2,r2,r1;
	double scx,scy,scz,bcx,bcy,bcz;
	for(i=0;i<ncore;i++){
		sid = SCOREID2COREID(i);
		slist = (int*)Malloc(sizeof(int)*np,PPTR(slist));
		snp = GetMemList(np,sid, slist);
		slist = Realloc(slist,sizeof(int)*snp);
		getcenter(slist,snp,scx,scy,scz,core,sid);
		core[sid].Rtidal = MAX_TIDAL_R;
		if(snp>0){
			for(j=i+1;j<ncore;j++){
				bid = SCOREID2COREID(j);
				blist = (int*)Malloc(sizeof(int)*np,PPTR(blist));
				bnp = GetMemList(np,bid, blist);
				blist = Realloc(blist,sizeof(int)*bnp);
				getcenter(blist,bnp,bcx,bcy,bcz,core,bid);
				r2 = (bcx-scx)*(bcx-scx)+(bcy-scy)*(bcy-scy)+(bcz-scz)*(bcz-scz);
				if(bnp>0){
					inum = 0;
					for(k=0;k<bnp;k++){
						tmpx = bp[blist[k]].x - bcx;
						tmpy = bp[blist[k]].y - bcy;
						tmpz = bp[blist[k]].z - bcz;
						dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
						if(dist2< r2) inum++;
					}
					if(inum >0){
						mtmp = (int)((float) snp / (float) inum * (float) NUM_MASS);
						if(mtmp >= NUM_MASS) {
							/*
							core[sid].Rtidal = MIN(core[sid].Rtidal,sqrt(r2));
							*/
						}
						else 
							core[sid].Rtidal = MIN(core[sid].Rtidal, sqrt(r2)*r_tidal[mtmp]);
					}
					else{
						core[sid].Rtidal = MIN(core[sid].Rtidal, MAX_TIDAL_R);
					}

				}
				Free(blist);
			}
		}
#ifdef DEBUG
		printf("C%d has tidal radius %g in r1=%g\n",sid,core[sid].Rtidal,sqrt(r2));
#endif
		Free(slist);
	}
}
void UnboundShellP2Rest(int ishell,basicparticletype *bp){
	int i,j,k;
	for(i=0;i<NSHELL2P(ishell);i++) 
		if(IS_BOUND(SHELL2P(ishell)[i]) == NOT) {
			SET_MEMBER_ID(SHELL2P(ishell)[i],NOT_HALO_MEMBER);
			SET_REMAINING(SHELL2P(ishell)[i]);
		}
}

#define DumpKPfromBP(kp,list,nlist){\
	int ii;\
	for(ii=0;ii<nlist;ii++){\
		kp[ii].x = bp[list[ii]].x;\
		kp[ii].y = bp[list[ii]].y;\
		kp[ii].z = bp[list[ii]].z;\
		kp[ii].vx = bp[list[ii]].vx;\
		kp[ii].vy = bp[list[ii]].vy;\
		kp[ii].vz = bp[list[ii]].vz;\
		kp[ii].bp = bp+list[ii];\
	}\
}
void MemberFoF(basicparticletype *bp,int np, int numcore, Coretype *core){
	float fof_link;
	int i,j,k;
	int num;
	FoFTPtlStruct *ptl;
	Box box;
	FoFTStruct *TREE;
	particle *linked,p;

	fof_link = FOF_LINK*nspace;
	ptl = (FoFTPtlStruct *) Malloc(sizeof(FoFTPtlStruct)*np,PPTR(ptl));
	linked = (particle *)Malloc(sizeof(particle)*np,PPTR(linked));
	TREE = (FoFTStruct *)Malloc(sizeof(FoFTStruct)*np,PPTR(TREE));
	for(i=0;i<numcore;i++){
		num = 0;
		for(j=0;j<np;j++){
			if(wp[j].haloid==i){
				ptl[num].type = TYPE_PTL;
				ptl[num].r[0] = bp[j].x;
				ptl[num].r[1] = bp[j].y;
				ptl[num].r[2] = bp[j].z;
				ptl[num].indx = j;
				ptl[num].sibling = &ptl[num+1];
				ptl[num].included = NO;
				num++;
			}
		}
		if(num ==0) continue;
		ptl[num-1].sibling = NULL;
		box = foffindbox(ptl,num);
		p.x = bp[core[i].peak].x;
		p.y = bp[core[i].peak].y;
		p.z = bp[core[i].peak].z;

		FoF_Make_Tree(TREE,ptl,num,box);
		new_fof_link(&p,fof_link,TREE,ptl,linked);
		k = num;
		for(j=0;j<num;j++){
			if(ptl[j].included == NO){
				SET_MEMBER_ID(ptl[j].indx,NOT_HALO_MEMBER);
				UNSET_BOUND(ptl[j].indx);
				SET_REMAINING(ptl[j].indx);
				k--;
			}
		}
#ifdef DEBUG
		printf("H%d 's # of members changes from %d to %d\n",i,num,k);
#endif
	}
	Free(TREE);Free(linked);Free(ptl);
}
int	AdGetMemberRestParticleList(basicparticletype *bp,int np,int hid,int *list,
		Coretype *core, Coresorttype *score,int now,int numcore){
	int i,j,k,num,onum,inum;
	int id;
	float cx,cy,cz;
	float rt2;
	float tmpx,tmpy,tmpz,dist2;
	cx = core[hid].cx; cy = core[hid].cy; cz = core[hid].cz;
	rt2 = (core[hid].Rtidal)*(core[hid].Rtidal);
	
	num = 0;
	for(i=0;i<np;i++){
		if(wp[i].haloid==hid){
			list[num++] = i;
		}
	}
	onum = num;
	for(i=0;i<np;i++){
		if(wp[i].haloid != hid){
			tmpx =  bp[i].x-cx; tmpy =  bp[i].y-cy; tmpz =  bp[i].z-cz;
			dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
			if(dist2 <= rt2) list[num++] = i;
		}
	}
    inum = onum;
	for(i=onum;i<num;i++){
		id = wp[list[i]].haloid;
		if(id==NOT_HALO_MEMBER) {
			list[inum++] = list[i];
		}
		else {
			for(j=now+1;j<numcore;j++){
				if(id == SCOREID2COREID(j)){
					list[inum++] = list[i];
					break;
				}
			}
		}
	}
	num = inum;
	return num;
}
int	GetMemberRestParticleList(basicparticletype *bp,int np,int hid,int *list,
		Coretype *core, Coresorttype *score,int now,int numcore){
	int i,j,k,num,onum,inum;
	int id;
	float cx,cy,cz;
	float rt2;
	float tmpx,tmpy,tmpz,dist2;
	cx = core[hid].cx; cy = core[hid].cy; cz = core[hid].cz;
	rt2 = (core[hid].Rtidal)*(core[hid].Rtidal);
	
	num = 0;
	for(i=0;i<np;i++){
		tmpx =  bp[i].x-cx; tmpy =  bp[i].y-cy; tmpz =  bp[i].z-cz;
		dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
		/* Include all the particles within the tidal radius irrepective of
		 * whether they are core particles to other halo candidates. */
		if(dist2 <= rt2) {
			list[num++] = i;
		}
		/* Erase from member list halo particles that are beyond the tidal radius. */
		else if(wp[i].haloid == hid){
			SET_MEMBER_ID(i,NOT_HALO_MEMBER);
			SET_REMAINING(i);
		}
	}
	inum = 0;
	for(i=0;i<num;i++){
		id = wp[list[i]].haloid;
		/* If it is the member particle or free, simply include it to the list. */
		if(id==NOT_HALO_MEMBER || id == hid) {
			list[inum++] = list[i];
		}
		/* If it is not a core particle of another halo and it is 
		 * a member particle of larger system, then include it. */
		else if(IS_CORE(i) == NOT) {
			for(j=now;j<numcore;j++){
				if(id == SCOREID2COREID(j)){
					list[inum++] = list[i];
					break;
				}
			}
		}
	}
	num = inum;
	return num;
}
/*
int	GetMemberRestParticleList(basicparticletype *bp,int np,int hid,int *list,
		Coretype *core, Coresorttype *score,int now,int numcore){
	int i,j,k,num,onum,inum;
	int id;
	float cx,cy,cz,rt2;
	float tmpx,tmpy,tmpz,dist2;
	num = 0;
	cx = core[hid].cx; cy = core[hid].cy; cz = core[hid].cz;
	rt2 = core[hid].Rtidal*core[hid].Rtidal;
	for(i=0;i<np;i++){
		if(wp[i].haloid==hid || IS_REMAINING(i) != NOT){
			list[num++] = i;
		}
	}
	onum = num;
	for(i=0;i<np;i++){
		if(wp[i].haloid!=hid && IS_REMAINING(i) == NOT){
			tmpx =  bp[i].x-cx; tmpy =  bp[i].y-cy; tmpz =  bp[i].z-cz;
			dist2 = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
			if(dist2 <= rt2) list[num++] = i;
		}
	}
	inum = onum;
	for(i=onum;i<num;i++){
		id = wp[list[i]].haloid;
		if(id==NOT_HALO_MEMBER) continue;
		for(j=now+1;j<numcore;j++){
			if(id == SCOREID2COREID(j)){
				list[inum++] = list[i];
				break;
			}
		}
	}
	num = inum;
	return num;
}
*/



#define MAXNUMCORE 100000
int subhalo_den(basicparticletype *bp, lint np,lint *p2halo){
	int i,j,k,bid;
	float xinit,yinit,zinit;
	float xmax,ymax,zmax;
	int *neighbor,NumNeighbor,numcore;
	float dthreshold;
	float *density;
	Coretype core[MAXNUMCORE];
	Kptype *kp,*skp,*tkp;


	/*
	numstack = CurMemStack();
	*/
	for(i=0;i<np;i++){
		p2halo[i] = NOT_HALO_MEMBER;
	}

	NumNeighbor = MIN(27,np);


	{
		mklocalize(bp,np,&xinit,&yinit, &zinit,&xmax,&ymax,&zmax);
	}
	{
		neighbor = (int*)Malloc(sizeof(int)*np*NumNeighbor,PPTR(neighbor));
		density = (float*)Malloc(sizeof(float)*np,PPTR(density));
		findsphdensity(bp,np,neighbor,NumNeighbor,density);
#ifdef DEBUG
		printf("density calculates\n");
#endif
	}
	{
		numcore = finddenpeak(density,NumNeighbor,neighbor,np,core);
#ifdef DEBUG
		printf("%d numcore detected\n",numcore);
#endif
		wp = (WorkingParticle *)Malloc(sizeof(WorkingParticle)*np,PPTR(wp));
	}
renumcore :
	if(numcore ==1) {
		int nmem;
		Free(neighbor);
		kp = (Kptype*)Malloc(sizeof(Kptype)*np,PPTR(kp));
#ifdef DEBUG
		printf("Just after free neighbor \n");
#endif
		for(i=0;i<np;i++){
			kp[i].x = bp[i].x; kp[i].y = bp[i].y; kp[i].z = bp[i].z;
			kp[i].vx = bp[i].vx; kp[i].vy = bp[i].vy; kp[i].vz = bp[i].vz;
			kp[i].bp = bp+i;
		}
#ifdef DEBUG
		printf("Just after kp allocations \n");
#endif
		for(i=0;i<np;i++) SET_MEMBER_ID(i,NOT_HALO_MEMBER);
#ifdef DEBUG
		printf("Just before alonehalo for np=%d\n",np);
#endif
		nmem = ALONEHALO(kp,np,bp,0);
#ifdef DEBUG
		printf("Just after alonehalo \n");
#endif
		Free(kp);
		MemberFoF(bp,np,numcore,core);
		for(i=0;i<np;i++){
			if(wp[i].haloid==0) p2halo[i] = 0;
			else p2halo[i] = NOT_HALO_MEMBER;
		}
		Free(wp);
	}
	else if(numcore > 1) {
		float minshellden,maxshellden;
		int ishell,nshelldivide;

		Dump2WorkingParticle(density,np,core,numcore);

		numcore = FindCoreDensity(bp,np,neighbor,NumNeighbor,core,numcore);
		Free(density);
		if(numcore ==1) {
			goto renumcore;
		}
		else if(numcore ==0) {
			Free(wp);Free(density);Free(neighbor);
			return numcore;
		}
#ifdef DEBUG
		printf("total number of cores changes to %d\n",numcore);fflush(stdout);
#endif

		minshellden = 1.e27;
		maxshellden = -1.e27;
		for(i=0;i<numcore;i++){ /* set the maximum value with the maximum core density */
			maxshellden = MAX(maxshellden,core[i].coredensity);
		}
		for(i=0;i<np;i++){ /* set the minium value with the minimum particle density */
			minshellden = MIN(minshellden,wp[i].den);
		}
		minshellden = log10(minshellden);
		maxshellden = log10(maxshellden);
		nshell = 0;
		if(np>1000) {
			nshelldivide = MAX(NSHELLDIVIDE*2.,NSHELLDIVIDE*log10((double)np));
		}
		else nshelldivide = NSHELLDIVIDE;
		for(i=0;i<nshelldivide;i++){
			dthreshold = minshellden + (nshelldivide-1-i)*
				(maxshellden-minshellden)/(float)nshelldivide;
			dthreshold = pow(10.,dthreshold);
			GetShellParticlesPeaks(np,neighbor,NumNeighbor,core,numcore,dthreshold);
		}
		SaveRemainingParticles2LastShell(np,core,numcore);
#ifdef DEBUG
		for(i=0;i<nshell;i++)
		 printf("S%d has %d particles & %d cores\n",i, NSHELL2P(i),NSHELL2C(i));
#endif
		/*
		goto gogo;
		*/
		for(ishell=0;ishell<nshell;ishell++){
			int icore;
			int *halonmem;
			float tradius;
			Coresorttype *score;
			score = (Coresorttype*)Malloc(sizeof(Coresorttype)*NSHELL2C(ishell),PPTR(score));

			halonmem = (int *) Malloc(sizeof(int)*numcore,PPTR(halonmem));
			for(j=0;j<numcore;j++) halonmem[j] = 0;
			for(j=0;j<np;j++)
				if(wp[j].haloid>=0) halonmem[wp[j].haloid]++;
			for(j=0;j<NSHELL2C(ishell);j++) {
				score[j].nmem =  halonmem[SHELL2C(ishell)[j]];
				score[j].core = core+SHELL2C(ishell)[j];
			}
			Free(halonmem);
			qsort(score,NSHELL2C(ishell),sizeof(Coresorttype),coresort);
#ifdef DEBUG
			for(j=0;j<NSHELL2C(ishell);j++) {
				k = SCOREID2COREID(j);
				printf("C%d has nmem=%d\n",k,core[k].nummem);
			}
#endif
			AdGetTidalRCenterCore(core,numcore, score,NSHELL2C(ishell),bp,np);

			for(j=0;j<NSHELL2C(ishell);j++) {
				int *tlist,ntarget;
				int *slist,nsource,nmem;
				icore = SCOREID2COREID(j);
				tlist = (int*)Malloc(sizeof(int)*np,PPTR(tlist));
				slist = (int*)Malloc(sizeof(int)*np,PPTR(slist));
				ntarget = GetShellParticleFromRestParticleLIST(bp,np,ishell, tlist,score[j].core);
				if(ntarget ==0) {
					Free(slist);Free(tlist);
					continue;
				}
				nsource = GetMemCandidateList(np,icore, slist,ishell);
				skp = (Kptype*)Malloc(sizeof(Kptype)*nsource,PPTR(skp));
				tkp = (Kptype*)Malloc(sizeof(Kptype)*ntarget,PPTR(tkp));
				DumpKPfromBP(skp,slist,nsource);
				DumpKPfromBP(tkp,tlist,ntarget);

				nmem = MULTIHALOSHELL(tkp,ntarget,skp,nsource,bp,np,core+icore);

				for(i=0;i<nmem;i++){
					bid = KP2BPID(tkp,i);
					SET_BOUND(bid);
					UNSET_REMAINING(bid);
					SET_MEMBER_ID(bid,icore);
#ifdef DEBUG
					/*
					printf("%g %g %g\n",bp[bid].x/4,bp[bid].y/4.,bp[bid].z/4.);
					*/
#endif
				}
				Free(tkp);Free(skp);
				Free(slist); Free(tlist);
#ifdef DEBUG
				printf("S%d in S%d -- C%d ntarget=%d nsource=%d & finally get nmem = %d\n",
						ishell,nshell,icore,ntarget,nsource,nmem);
#endif
			}
			UnboundShellP2Rest(ishell,bp);/* Turning on the rest flag for unbound shell particles */
			Free(score);
		}
		MemberFoF(bp,np,numcore,core);
		/*
		for(i=0;i<np;i++){
			if(IS_REMAINING(i) != NOT && wp[i].haloid != NOT_HALO_MEMBER){
				printf("ERRORR\n");
			}
			if(IS_REMAINING(i) == NOT && wp[i].haloid == NOT_HALO_MEMBER){
				printf("ERRORRSSS\n");
			}
		}
		goto gogo;
		*/

		for(i=0;i<BOUNDITER;i++){
			int *tlist,ntarget,jcore,*halonmem;
			int kk,nbound;
			Coresorttype *score;
			score = (Coresorttype*)Malloc(sizeof(Coresorttype)*numcore,PPTR(score));
			halonmem = (int *) Malloc(sizeof(int)*numcore,PPTR(halonmem));
			for(j=0;j<numcore;j++) halonmem[j] = 0;
			for(j=0;j<np;j++)
				if(wp[j].haloid>=0) halonmem[wp[j].haloid]++;
			for(j=0;j<numcore;j++) {
				score[j].nmem =  halonmem[j];
				score[j].core = core+j;
			}
			Free(halonmem);

			qsort(score,numcore,sizeof(Coresorttype),coresort);
			AdGetTidalRCenterCore(core,numcore, score,numcore,bp,np);
#ifdef DEBUG
			for(j=0;j<numcore;j++){
				jcore = SCOREID2COREID(j);
				printf("C%d has nmem= %d & Rtidal= %g c %g %g %g\n",
						jcore,score[j].nmem,score[j].core->Rtidal,
						core[jcore].cx,core[jcore].cy,core[jcore].cz);
			}
#endif
			tlist = (int *)Malloc(sizeof(int)*np,PPTR(tlist));
			for(j=0;j<numcore;j++){
				Kptype *kp;
				jcore = SCOREID2COREID(j);
				if(score[j].nmem==0) continue;
				/*
				ntarget = AdGetMemberRestParticleList(bp,np,jcore,tlist,core,score,j,numcore);
				*/
				ntarget = GetMemberRestParticleList(bp,np,jcore,tlist,core,score,j,numcore);
				if(ntarget ==0) continue;
				kp = (Kptype*)Malloc(sizeof(Kptype)*ntarget,PPTR(kp));
				DumpKPfromBP(kp,tlist,ntarget);
				nbound = SINGLEHALO(ntarget,kp,np,bp,jcore, core+jcore);
#ifdef DEBUG
				printf("C%d has bound particles of np= %d from mp= %d within rtidal= %g c %g %g %g\n",
						jcore,nbound, ntarget,core[jcore].Rtidal,
						core[jcore].cx,core[jcore].cy,core[jcore].cz);
#endif
				Free(kp);
			}
			Free(tlist); Free(score);
		}
		MemberFoF(bp,np,numcore,core);

#ifdef DEBUG
		/*
		MPI_Finalize();exit(99);
		*/
#endif
gogo:
		for(i=0;i<np;i++){
			p2halo[i] = wp[i].haloid;
		}
		Free(wp); Free(neighbor);
	}
	/*
	InitialOldMemStack(numstack);
	*/

	return numcore;
}
