#include<stdio.h>
#include<stdlib.h>
#include<math.h>
/*
#define READY 1
#define WRITING 3
#define NP_TAG 17
#define R_TAG 32
#define VR_TAG 83
#define INDX_TAG 24
#define PT2H_TAG 55
#define MPEAK_TAG 96
#define INIT_NP 3000000
*/
#include "header.h"
float m_tidal[NUM_MASS],r_tidal[NUM_MASS];
/*
#define MAX(A,B) ((A) > (B) ? (A) : (B))
#define MIN(A,B) ((A) < (B) ? (A) : (B))
#define G 6.672E-8
#define pc 3.08567802E18
#define pi 3.1415926535
*/
int Parallel;
/*
typedef int lint;
struct PtlPos{
	float x;float y;float z;
};
struct HaloPos{
	float x;float y;float z;
};
struct PtlVel{
	float vx;float vy;float vz;
};
struct HaloVel{
	float vx;float vy;float vz;
};
*/
struct HaloPos *hr;
struct HaloVel *hvr;
lint *hhasptl;
float *den;
lint *den2ptl;
int magnitude;
int myrank,nrank;
int shalonum,rhalonum;
lint *pt2h;
int tnp;
struct PtlPos *sx,*rx,*tr;
struct PtlVel *svx,*rvx;
lint *sindx;
lint *rindx;
lint *ptl2halonum;
int mpeak;
int ready=READY,writing=WRITING;
int snp,rnp;
FILE *wp;
/*                              */
float amax,a,rng,size,hubble;
int ng,nspace;
float omep,omeplam,epsilon;
int nx,ny,nz;
/*                              */
double com2real,real2com;
double pntmass,r1kineticfact,r2kineticfact;
double potentfact;
float acoeff[8];
double onesolarmass=1.989E33;

void write_data(struct PtlPos *,struct PtlVel *,lint *,int);
void HDF_write_data(struct PtlPos *,struct PtlVel *,lint *,int);

extern int physical_parameters(void);
int subhalo_den(struct PtlPos *,struct PtlVel *, lint *, lint,float ,lint *,
		int);
float find_tidal_Rc(struct PtlPos *,lint ,struct PtlPos *,lint ,
	        struct HaloPos *,struct HaloVel *,struct HaloPos *,
	        struct HaloVel *,int,int);
int num_pick_up_r_ptl(struct PtlPos *,int ,int *,struct PtlPos *,int );
void pspline_(void);


int main(int argc, char *argv[])
{
	int i,j,snp,rnp,flag;
	int ib;
	int finish=-99999;
	int snend,rnend;
	int src,dest;
	int job,check;
	/*          */
	struct HaloPos *csx,*crx;
	struct HaloVel *csvx,*crvx;
	float tmp_tidal,tmp;
	float *floatsx, *floatrx;
	int *swap;
	lint *pptr;
	float *potent,*tmppotent;
	/*          */
	float h;
	FILE *fp,*rtidalf;
	myrank = motherrank;
	if(argc != 12){
		if(myrank == motherrank)
		fprintf(stderr,".... hfind.exe [ng] [nspace] [omep] [omeplam] [hubble] [size] [amax] [a] [epsilon] [h] [mag]\n");
		exit(1);
	}
/* reading tidal data for tidal radius calculation */
	if(myrank == motherrank){
		rtidalf = fopen("tidal.dat","r");
		for(i=0;i<NUM_MASS;i++){
			fscanf(rtidalf,"%g %g %g\n",&m_tidal[i],&r_tidal[i],&tmp);
		}
		fclose(rtidalf);
	}
/*
	MPI_Bcast(m_tidal,NUM_MASS,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
	MPI_Bcast(r_tidal,NUM_MASS,MPI_FLOAT,motherrank,MPI_COMM_WORLD);
*/
/* end of setting tidal radius according to mass ratio */
	ng = atoi(argv[1]); rng = ng;
	nx = ny = nz = ng;
	nspace = atoi(argv[2]);
	omep = atof(argv[3]);
	omeplam = atof(argv[4]);
	hubble = atof(argv[5]);
	size = atof(argv[6]);
	amax = atof(argv[7]);
	a = atof(argv[8]);
	epsilon = atof(argv[9]);
	epsilon = (nspace*0.1)*(nspace*0.1);
	h = atof(argv[10]);
	magnitude = atoi(argv[11]);

	acoeff[0] = 1.;
	check = physical_parameters();
	Parallel = 0;
	snend = rnend = INIT_NP;
	shalonum = rhalonum = 0;
		fprintf(stdout,"each processor calculates individual halos\n");	
		rx = (struct PtlPos *)malloc(sizeof(struct PtlPos)*INIT_NP);
		rvx = (struct PtlVel *)malloc(sizeof(struct PtlVel)*3*INIT_NP);
		rindx = (lint *)malloc(sizeof(lint)*INIT_NP);
		ptl2halonum = (lint *)malloc(sizeof(lint)*INIT_NP);
		fp = fopen("Halo.Dat","r");
#ifndef HDF5
		wp = fopen("HFIND.DATA","a");
#endif
		while(fread(&snp,sizeof(lint),1,fp) == 1){
			snend = MAX(snend,snp);
			sx = realloc(sx,sizeof(struct PtlPos)*snend);
			svx = realloc(svx,sizeof(struct PtlVel)*snend);
			sindx = realloc(sindx,sizeof(lint)*snend);
			ptl2halonum = realloc(ptl2halonum,sizeof(lint)*snend);
			fread(sx,sizeof(struct PtlPos),snp,fp);
			fread(svx,sizeof(struct PtlVel),snp,fp);
			fread(sindx,sizeof(lint),snp,fp);
			mpeak = subhalo_den(sx,svx,sindx,snp,h,ptl2halonum,Parallel);
		}
	exit(0);
}
void bin2ascii(struct PtlPos *,struct PtlVel *,lint );
void write_data(struct PtlPos *rx,struct PtlVel *rvx,lint *rindx,int rnp){
	struct PtlPos *wr;
	struct PtlVel *wvr;
	lint *windx;
	lint wnp;
	int i,j,k;

	if(myrank == 0 && mpeak >0 ) {
		fprintf(stderr,"Halo group has %d particles... saving..",rnp);
		fflush(stderr);
	}


	if (mpeak > 0){
                fwrite(&mpeak,sizeof(int),1,wp);
		wr = (struct PtlPos *)malloc(sizeof(struct PtlPos)*rnp);
		wvr = (struct PtlVel *)malloc(sizeof(struct PtlVel)*rnp);
		windx = (lint *)malloc(sizeof(lint)*rnp);
		for(i=0;i<mpeak;i++){
			wnp = 0;
			for(j=0;j<rnp;j++){
				if(ptl2halonum[j] == i){
					wr[wnp].x = rx[j].x*size/(float) ng;
					wr[wnp].y = rx[j].y*size/(float) ng;
					wr[wnp].z = rx[j].z*size/(float) ng;
					wvr[wnp].vx = rvx[j].vx*r2kineticfact/100000.;
					wvr[wnp].vy = rvx[j].vy*r2kineticfact/100000.;
					wvr[wnp].vz = rvx[j].vz*r2kineticfact/100000.;
					windx[wnp] = rindx[j];
					wnp++;
				}
			}
			fwrite(&wnp,sizeof(lint),1,wp);
			fwrite(wr,sizeof(struct PtlPos),wnp,wp);
			fwrite(wvr,sizeof(struct PtlVel),wnp,wp);
			fwrite(windx,sizeof(lint),wnp,wp);
			fprintf(stdout,"in %d halos ,halomass %12G %d \n",mpeak,pntmass*wnp/onesolarmass,wnp);
			fflush(stdout);
		}
		free(wr);free(wvr);free(windx);
	}
	if(myrank == 0 && mpeak >0 ) {
		fprintf(stderr,"saved.\n");
	}
#ifdef CHECK_HALO
    bin2ascii(rx,rvx,rnp);
#endif
}
void minmax(struct PtlPos *,int ,float *,float *, float *,float *,float *, float *,float *);
void bin2ascii(struct PtlPos *r,struct PtlVel *vr,lint np)
{
	int i,j;
	FILE *fp,*fpt,*fptz;
	char char1;
	float minx,minz,maxx,maxz,miny,maxy,width;
	int uline,dline;
	char *ctype[] = {"yellow", "blue", "red","green","6",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red" };
	fp = fopen("halo0.dat","w");
	fpt = fopen("r.sm","w");
	fptz = fopen("z.sm","w");
	fprintf(fpt,"erase \n");
	fprintf(fptz,"erase \n");
	fprintf(fpt,"ticksize 0.1 1 0.1 1 \n");
	fprintf(fptz,"ticksize 0.1 1 0.1 1 \n");
	fprintf(fpt,"data halo0.dat \n");
	fprintf(fptz,"data halo0.dat \n");
	fprintf(fpt," ptype 0 0 \n");
	fprintf(fptz," ptype 0 0 \n");
	minmax(r,np,&minx,&maxx,&miny,&maxy,&minz,&maxz,&width);
	minx = floor(minx);minz = floor(minz);width = ceil(width)+1;
	fprintf(fpt," limits %f %f %f %f \n",minx,minx+width,minz,minz+width);
	fprintf(fptz," limits %f %f %f %f \n",minx,minx+width,miny,miny+width);
	fprintf(fpt," ctype default \n");
	fprintf(fptz," ctype default \n");
	fprintf(fpt," expand 1.2 \n");
	fprintf(fptz," expand 1.2 \n");
	fprintf(fpt," box \n");
	fprintf(fptz," box \n");
	fprintf(fpt," expand 0.3 \n");
	fprintf(fptz," expand 0.3 \n");
	uline = 1;dline = 0;
	for(j=0;j<mpeak;j++){
		for(i=0;i<np;i++){
			if(ptl2halonum[i] == j){
			fprintf(fp,"%f %f %f %f %f %f \n",r[i].x,r[i].y,r[i].z,
					vr[i].vx,vr[i].vy,vr[i].vz);
			dline++;
			}
		}
		fflush(fp);
		if(dline > uline ){
		fprintf(fpt," lines %d %d \n",uline,dline);
		fprintf(fptz," lines %d %d \n",uline,dline);
		fprintf(fpt," read { x 1 y 2 z 3} \n");
		fprintf(fptz," read { x 1 y 2 z 3} \n");
  		fprintf(fpt," ctype %s \n",*(ctype+j));
  		fprintf(fptz," ctype %s \n",*(ctype+j));
		fprintf(fpt," points x z \n");
		fprintf(fptz," points x y \n");
		fflush(fpt);
		}
		uline = dline + 1;
	}
	/* ̹  ׶ ƼŬ̴. */
	uline = dline;
	for(i=0;i<np;i++){
		if(ptl2halonum[i]<0){
			fprintf(fp,"%f %f %f %f %f %f \n",r[i].x,r[i].y,r[i].z,
					vr[i].vx,vr[i].vy,vr[i].vz);
			dline++;
		}
	}
	fprintf(fpt," lines %d %d \n",uline,dline);
	fprintf(fptz," lines %d %d \n",uline,dline);
	fprintf(fpt," read { x 1 y 2 z 3} \n");
	fprintf(fptz," read { x 1 y 2 z 3} \n");
  	fprintf(fpt," ctype default \n");
  	fprintf(fptz," ctype default \n");
	fprintf(fpt," points x z \n");
	fprintf(fptz," points x y \n");
	fflush(fpt);
	fflush(fptz);
	fclose(fpt);
	fclose(fptz);
	fflush(fp);
	fclose(fp);
	printf("input arbitrary value : ");
	char1 = getc(stdin);
	fflush(stdin);
}

void minmax(struct PtlPos *r,int np,float *minx,float *maxx,
		float *miny,float *maxy,float *minz,
		float *maxz,float *width){
	int i;
	*minx = *miny = *minz = 1000;
	*maxx = *maxy = *maxz = 0;
	for(i=0;i<np;i++){
		*minx = MIN(*minx,r[i].x);
		*miny = MIN(*miny,r[i].y);
		*minz = MIN(*minz,r[i].z);
		*maxx = MAX(*maxx,r[i].x);
		*maxy = MAX(*maxy,r[i].y);
		*maxz = MAX(*maxz,r[i].z);
	}
	*width = MAX(*maxx-*minx,*maxz-*minz);
	*width = MAX(*width,*maxy-*miny);
	*width = MAX(*width,4.);
}

